;M E S S A G E S

;Allgemeines
MSC_GEN_QUIT    equ 0   ;Programm wird aufgefordert, sich zu beenden

;Kernel Commands
MSC_KRL_MTADDP  equ 1   ;Prozess hinzufgen (P1/2=Stack, P3=Prioritt (7hoch-1niedrig), P4=Bank (0-8))
MSC_KRL_MTDELP  equ 2   ;Prozess entfernen (P1=Nummer)
MSC_KRL_MTADDT  equ 3   ;Timer hinzufgen (P1/2=Stack, P4=Bank (0-8))
MSC_KRL_MTDELT  equ 4   ;Timer entfernen (P1=Nummer)
MSC_KRL_MTSLPP  equ 5   ;Prozess in Dauer-Schlafzustand versetzen
MSC_KRL_MTWAKP  equ 6   ;Prozess aus Dauer-Schlafzustand holen

;Kernel Responses
MSR_KRL_MTADDP  equ 129 ;Prozess wurde hinzugefgt (P1=0/1->ok/failed, P2=Nummer)
MSR_KRL_MTDELP  equ 130 ;Prozess wurde entfernt
MSR_KRL_MTADDT  equ 131 ;Timer wurde hinzugefgt (P1=0/1->ok/failed, P2=Nummer)
MSR_KRL_MTDELT  equ 132 ;Timer wurde entfernt
MSR_KRL_MTSLPP  equ 133 ;Prozess wurde in Dauer-Schlafzustand versetzt
MSR_KRL_MTWAKP  equ 134 ;Prozess wurde aus Dauer-Schlafzustand geholt

;System Commands
MSC_SYS_PRGRUN  equ 16  ;Programm laden und starten
MSC_SYS_PRGEND  equ 17  ;Programm beenden
;System Responses
MSR_SYS_PRGRUN  equ 144 ;Programm wurde geladen (P1=Result [0=ok, 1=Datei existiert nicht, 2=Datei ist kein Programm, 3=Fehler beim Laden, 4=Speicher voll])

;Desktop Commands
MSC_DSK_WINOPN  equ 32  ;Neues Fenster anlegen (P1=Bank, P2/3=Adresse Datensatz) A/IY=Adresse Datensatz =>> CF=0-> A=Fensternummer, CF=1-> Speicher voll)
MSC_DSK_WINMEN  equ 33  ;Baut Menueleiste eines Fensters auf (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WININH  equ 34  ;Zeichnet Fensterinhalt (P1=Fensternummer, P2=-1/Objekt) (I/IY,A,CF=1) [nur Top]
MSC_DSK_WINTOL  equ 35  ;Zeichnet Toolleiste (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINTIT  equ 36  ;Gibt Fenstertitel aus (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINSTA  equ 37  ;Gibt Fensterstatus aus (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINMVX  equ 38  ;Setzt Fensterinhalt-Beginn im X-Bereich (P1=Fensternummer, P2/3=XPos) (I/IY,DE) [nur Top]
MSC_DSK_WINMVY  equ 39  ;Setzt Fensterinhalt-Beginn im Y-Bereich (P1=Fensternummer, P2/3=XPos) (I/IY,DE) [nur Top]
MSC_DSK_WINTOP  equ 40  ;Holt Fenster nach vorne (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMAX  equ 41  ;Maximiert Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMIN  equ 42  ;Minimiert Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMID  equ 43  ;Wiederherstellt Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMOV  equ 44  ;Verschiebt Fenster (P1=Fensternummer, P2/3=XPos, P4/5=YPos) (A,DE/HL) [immer]
MSC_DSK_WINSIZ  equ 45  ;Setzt Fenster-Groesse (P1=Fensternummer, P2/3=XPos, P4/5=YPos) (A,DE/HL) [immer]
MSC_DSK_WINCLS  equ 46  ;Schliesst und entfernt Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINDIN  equ 47  ;Redrawt den Fensterinhalt eines Fensters, welches nicht Focus hat (P1=Fensternummer, P2=-1/Objekt) (A,E) [immer]
MSC_DSK_DSKSRV  equ 48  ;Desktop-Service-Anfrage (P1=Typ, P2-P5=Parameter)

;Desktop Responses
MSR_DSK_WOPNER  equ 160 ;Fensterffnen gescheitert (kein Speicher)
MSR_DSK_WOPNOK  equ 161 ;Fensterffnen erfolgreich (P4=Nummer)
MSR_DSK_WCLICK  equ 162 ;Fenster wurde geklickt (P1=Fensternummer, P2=Aktion, P4/5,P6/7,P8/9=Parameter)
MSR_DSK_DSKSRV  equ 163 ;Desktop-Service-Antwort (P1=Typ, P2-P5=Parameter)


;D E S K T O P - A K T I O N
DSK_ACT_CLOSE   equ 5   ;Close-Button wurde geklickt
DSK_ACT_MENU    equ 6   ;Menu wurde geklickt (P8/9=Menupunkt-Wert)
DSK_ACT_CONTENT equ 14  ;Inhalt wurde geklickt (P8/9=Objekt-Wert)
DSK_ACT_TOOLBAR equ 15  ;Toolbar wurde geklickt (P8/9=Objekt-Wert)


;J U M P S
jmp_memsum  equ #8100 ;MEMSUM
jmp_sysinf  equ #8103 ;SYSINF
jmp_clcnum  equ #8106 ;CLCNUM
jmp_mtgcnt  equ #8109 ;MTGCNT
jmp_timget  equ #810C ;TIMGET
jmp_timset  equ #810F ;TIMSET

.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 56  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatLen     equ 256 ;

.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;
