;M E S S A G E S

;Allgemeines
MSC_GEN_QUIT    equ 0   ;Programm wird aufgefordert, sich zu beenden

;Kernel Commands
MSC_KRL_MTADDP  equ 1   ;Prozess hinzufgen (P1/2=Stack, P3=Prioritt (7hoch-1niedrig), P4=Bank (0-8))
MSC_KRL_MTDELP  equ 2   ;Prozess entfernen (P1=Nummer)
MSC_KRL_MTADDT  equ 3   ;Timer hinzufgen (P1/2=Stack, P4=Bank (0-8))
MSC_KRL_MTDELT  equ 4   ;Timer entfernen (P1=Nummer)
MSC_KRL_MTSLPP  equ 5   ;Prozess in Dauer-Schlafzustand versetzen
MSC_KRL_MTWAKP  equ 6   ;Prozess aus Dauer-Schlafzustand holen

;Kernel Responses
MSR_KRL_MTADDP  equ 129 ;Prozess wurde hinzugefgt (P1=0/1->ok/failed, P2=Nummer)
MSR_KRL_MTDELP  equ 130 ;Prozess wurde entfernt
MSR_KRL_MTADDT  equ 131 ;Timer wurde hinzugefgt (P1=0/1->ok/failed, P2=Nummer)
MSR_KRL_MTDELT  equ 132 ;Timer wurde entfernt
MSR_KRL_MTSLPP  equ 133 ;Prozess wurde in Dauer-Schlafzustand versetzt
MSR_KRL_MTWAKP  equ 134 ;Prozess wurde aus Dauer-Schlafzustand geholt

;System Commands
MSC_SYS_PRGRUN  equ 16  ;Programm laden und starten
MSC_SYS_PRGEND  equ 17  ;Programm beenden
;System Responses
MSR_SYS_PRGRUN  equ 144 ;Programm wurde geladen (P1=Result [0=ok, 1=Datei existiert nicht, 2=Datei ist kein Programm, 3=Fehler beim Laden, 4=Speicher voll])

;Desktop Commands
MSC_DSK_WINOPN  equ 32  ;Neues Fenster anlegen (P1=Bank, P2/3=Adresse Datensatz) A/IY=Adresse Datensatz =>> CF=0-> A=Fensternummer, CF=1-> Speicher voll)
MSC_DSK_WINMEN  equ 33  ;Baut Menueleiste eines Fensters auf (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WININH  equ 34  ;Zeichnet Fensterinhalt (P1=Fensternummer, P2=-1/Objekt) (I/IY,A,CF=1) [nur Top]
MSC_DSK_WINTOL  equ 35  ;Zeichnet Toolleiste (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINTIT  equ 36  ;Gibt Fenstertitel aus (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINSTA  equ 37  ;Gibt Fensterstatus aus (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINMVX  equ 38  ;Setzt Fensterinhalt-Beginn im X-Bereich (P1=Fensternummer, P2/3=XPos) (I/IY,DE) [nur Top]
MSC_DSK_WINMVY  equ 39  ;Setzt Fensterinhalt-Beginn im Y-Bereich (P1=Fensternummer, P2/3=XPos) (I/IY,DE) [nur Top]
MSC_DSK_WINTOP  equ 40  ;Holt Fenster nach vorne (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMAX  equ 41  ;Maximiert Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMIN  equ 42  ;Minimiert Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMID  equ 43  ;Wiederherstellt Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMOV  equ 44  ;Verschiebt Fenster (P1=Fensternummer, P2/3=XPos, P4/5=YPos) (A,DE/HL) [immer]
MSC_DSK_WINSIZ  equ 45  ;Setzt Fenster-Groesse (P1=Fensternummer, P2/3=XPos, P4/5=YPos) (A,DE/HL) [immer]
MSC_DSK_WINCLS  equ 46  ;Schliesst und entfernt Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINDIN  equ 47  ;Redrawt den Fensterinhalt eines Fensters, welches nicht Focus hat (P1=Fensternummer, P2=-1/Objekt) (A,E) [immer]
MSC_DSK_DSKSRV  equ 48  ;Desktop-Service-Anfrage (P1=Typ, P2-P5=Parameter)

;Desktop Responses
MSR_DSK_WOPNER  equ 160 ;Fensterffnen gescheitert (kein Speicher)
MSR_DSK_WOPNOK  equ 161 ;Fensterffnen erfolgreich (P4=Nummer)
MSR_DSK_WCLICK  equ 162 ;Fenster wurde geklickt (P1=Fensternummer, P2=Aktion, P4/5,P6/7,P8/9=Parameter)
MSR_DSK_DSKSRV  equ 163 ;Desktop-Service-Antwort (P1=Typ, P2-P5=Parameter)


;D E S K T O P - A K T I O N
DSK_ACT_CLOSE   equ 5   ;Close-Button wurde geklickt
DSK_ACT_MENU    equ 6   ;Menu wurde geklickt (P8/9=Menupunkt-Wert)
DSK_ACT_CONTENT equ 14  ;Inhalt wurde geklickt (P8/9=Objekt-Wert)
DSK_ACT_TOOLBAR equ 15  ;Toolbar wurde geklickt (P8/9=Objekt-Wert)


;J U M P S
jmp_memsum  equ #8100 ;MEMSUM
jmp_sysinf  equ #8103 ;SYSINF
jmp_clcnum  equ #8106 ;CLCNUM
jmp_mtgcnt  equ #8109 ;MTGCNT
jmp_timget  equ #810C ;TIMGET
jmp_timset  equ #810F ;TIMSET

.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 56  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatLen     equ 256 ;

.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;
SYMBOS_ORG #100
;**** 256 Application Header ****
.AppCodBeg     dw  AppDatBeg-AppCodBeg      ;Length of Cod
              dw  AppTrnBeg-AppDatBeg      ;Length of Dat
              dw  AppTrnEnd-AppTrnBeg      ;Length of Transfe
.AppDatAdr     dw  #100                    ;Original Origi
.AppTrnAdr     dw  0                        ;Number of Entries In Relocation Tabl
.AppPrzLst     dw  AppStk-AppTrnBeg         ;Stack Lengt
              dw  0                        ;Length of Crunched Dat
.AppBnkNum     db  0                        ;Crunch Typ
.AppNam        db  "SymbOS Application              ",0
.AppMemTab     db  "SymExe10"             ;File Check
              ds  34
.AppIcnSml    
        db 2,8,8
      db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00

        db 6,24,24
      db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
      db  #00,#00,#00,#00,#00,#11,#FF,#FF,#FF,#CF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
      db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#17,#FF,#7F,#FF,#4E,#00,#00,#00,#00
      db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
      db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
      db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00

;***************
;**** Code *****
;***************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_Control_ID		db	0
.V_App_Control_Addr		dw	0
.V_App_Form_ID			db	0
.V_App_Form_Addr		dw 	0
.V_App_Action_ID		db	0
.V_App_OS_Form			db  0

.AppPrz:
       ld    a,(AppPrzN)
       ld    (Form1+WinDatPrz),a
       db    #dd:ld l,a
       ld    a,(DskPrzN)
       db    #dd:ld h,a
       ld    a,(AppBnkNum)
       ld    h,a
       ld    l,MSC_DSK_WINOPN
       ld    (AppMsgB),hl
       ld    hl,Form1
       ld    (AppMsgB+2),hl
       ld    iy,AppMsgB
       rst   #10
.App_Prz1:
       call  App_Wait_Message
       jr    nc,App_Prz1
       ld    a,(DskPrzN)
       db    #dd:cp h
       jr    nz,App_Prz1
       ld    a,(AppMsgB)
       cp    MSR_DSK_WOPNER
       jp    z,App_End
       cp    MSR_DSK_WOPNOK
       jr    nz,App_Prz1
       ld    a,(AppMsgB+4)
       ld    (AppWin),a
.App_Control_Loop:
       call   App_Wait_Message
       jr     nc,App_Control_Loop0
       cp     MSR_DSK_WCLICK
       jr     nz,App_Control_Loop0
       ld     a,(AppMsgB+2)
       cp     DSK_ACT_CLOSE
       jp     z,App_End
       cp     DSK_ACT_MENU
       jp     z,App_Menu
       cp     DSK_ACT_CONTENT
       jp     z,App_Content
.App_Control_Loop0:
       jr     App_Control_Loop

.App_Menu:
       ld     a,(AppMsgB+9)
       cp     #0
       jp     z,App_Control_Loop
       ld     hl,(AppMsgB+8)
       ld     (App_Call_Set2+1),hl
.App_Call_Set2:
       call   0
       jp     App_Control_Loop

.App_Content:
	call	App_Store_Message
	ld		hl,(V_App_Control_Addr)
	ld		de,2
	add		hl,de
	ld		a,(hl)						;**** Get type
	cp		20
	jp		z,Check_Tabs

.App_Content2:
	ld		hl,(V_App_Control_Addr)
	ld		de,14
	add		hl,de
	call	App_CallUserEvent
	jp		App_Control_Loop

;**** Calls a User Event if it exists
;**** IN HL = Location of the address of the event
.App_CallUserEvent:
	ld		e,(hl)						;**** Get type
	inc		hl
	ld		a,(hl)
	cp		0
	jp		z,App_Control_Loop
	push	ix
	push	iy
	ld		(App_Content3+2),a
	ld		a,e
	ld		(App_Content3+1),a
	ld		a,(V_App_Action_ID)
.App_Content3:	
	call	0
	pop		iy
	pop		ix
	ret
	
.Check_Tabs:
	ld		hl,(V_App_Control_Addr)
	ld		de,#4
	call 	Sys_HL_Addr
;**** Lets update OldValue	
	ld		de,2				;Point to Halue
	add		hl,de				;
	ld		a,(hl)				;a=Value
	ld		de,-4				;Point to OldValue
	add		hl,de				;
	cp		(hl)
	jp		z,YakkiMoron		;Skip cos its the Same
	ld		(hl),a				;Old Value updated
;****
	inc		hl					;Point to VisGroup start
	ld		c,(hl)				;c=Visgroup start
	add		c					;a=Visgroup the be Shown ( Value + VisGroup Start)
	inc		hl					;Point to number of Tabs
	ld		b,(hl)				;B= Number of Tabs
.MatadorShoes
	cp		c
	jr		z,ShowThisTab
.DontShowTab
	call	Sys_Visible_Off
	jr		Yukkie
.ShowThisTab
	call	Sys_Visible_On
.Yukkie
	inc		c
	djnz	MatadorShoes
	ld		hl,Sys_DisplayData
	ld		a,(V_App_Control_ID)
	sub		1
	ld		e,a
	ld		d,0
	add		hl,de
	ld		a,1
	ld		(hl),a
	inc		hl
	ld		(hl),a
	ld		hl,Sys_DisplayData
	ld		b,28
	ld		c,0
.GregorysGirl
	ld		a,(hl)
	cp		0
	jr		z,Gregorys2Girls
	ld		a,c

	push	bc
	push	hl
	Call	Sys_Redraw_Object
	pop		hl
	pop		bc
	ld		a,0
	ld		(hl),a
.Gregorys2Girls
	inc		c
	inc		hl
	djnz	GregorysGirl
.Yakkimoron
	jp		App_Content2

.App_Store_Message:
	ld		a,(AppMsgB+0)
	ld		(V_App_Action_ID),a
	ld		a,(AppMsgB+1)
	ld		(V_App_OS_Form),a
	ld		a,(AppMsgB+8)
	ld		(V_App_Control_ID),a
	ld		b,a
	ld		a,(AppMsgB+9)
	ld		(V_App_Form_ID),a
	ld		e,a
	ld		d,0
	ld		hl,AppFormLists
	add		hl,de
	add		hl,de
	ld		e,(hl)
	inc		hl
	ld		d,(hl)
	ld		(V_App_Form_Addr),de
	ld		l,b
	ld		h,0
	add		hl,hl					;**** Times 2
	add		hl,hl					;**** Times 4
	add		hl,hl					;**** Times 8
	add		hl,hl					;**** Times 16
	add		hl,de		
	ld		(V_App_Control_Addr),hl
	ret

.App_Wait_Message:
        rst   #30
        ld    a,(AppPrzN)
        db    #dd:ld l,a
        db    #dd:ld h,-1
        ld    iy,AppMsgB
        rst   #18
        Or    a
        db    #dd:dec l
        ret   nz
        ld    a,(AppMsgB+0)
        Or    a
        jr    z,App_End
        scf
        ret
.App_End:
        ld    a,(AppPrzN)
        db    #dd:ld l,a
        ld    a,(SysPrzN)
        db    #dd:ld h,a
        ld    a,(AppCodBeg+PrgPstNum)
        ld    h,a
        ld    l,MSC_SYS_PRGEND
        ld    (AppMsgB),hl
        ld    iy,AppMsgB
        rst   #10
.App_End0:
        rst   #30
        jr    App_End0

.Sys_Temp1:		dw	0

Sys_DisplayData:
		ds	256

;**** Basically Makes HL the contents of HL+DE
.Sys_HL_Addr
	add		hl,de
	ld		e,(hl)
	inc		hl
	ld		d,(hl)
	ex		de,hl
	ret
;**** System Routine ****
.Sys_Visible_On
	push	af
	push	bc
	push	de
	push	hl
;**** In 	C = Visability Group
;			B = Number of times To Loop
	ld		hl,(V_App_Form_Addr)
	ld		de,-16
	add		hl,de
	ld		b,(hl)
	ld		de,17
	add		hl,de
	ld		de,Sys_DisplayData
BwScangMuppet:
	ld		a,(hl)
	inc		hl
	And		%111111
	cp		c
	jr		nz,PhilCoolTugBoat
	ld		a,(hl)
	And		%111111
	ld		(hl),a
	ld		a,1
	ld		(de),a
PhilCoolTugBoat:
	inc		de
	push	de
	ld		de,15
	add		hl,de
	pop		de
	djnz	BwScangMuppet
	pop		hl
	pop		de
	pop		bc
	pop		af	
	ret

;**** System Routine ****
.Sys_Visible_Off
	push	af
	push	bc
	push	de
	push	hl
;**** In 	C = Visability Group
;			B = Number of times To Loop
	ld		hl,(V_App_Form_Addr)
	ld		de,-16
	add		hl,de
	ld		b,(hl)
	ld		de,17
	add		hl,de
	ld		de,15
BwScangMuppet2:
	ld		a,(hl)
	inc		hl
	And		%111111
	cp		c
	jr		nz,PhilCoolTugBoat2
	ld		a,(hl)
	Or		%11000000
	ld		(hl),a
PhilCoolTugBoat2:
	add		hl,de
	djnz	BwScangMuppet2
	pop		hl
	pop		de
	pop		bc
	pop		af
	ret

;**** System Routines ****
.Sys_Set_Visible:
;**** a = 0 \ Visible 1 \ Invisible
;**** b = Object
;**** c = Form
	And		%00000001
	rrca
	ld		e,c							;* e = form number
	ld		d,0							;* d = 0
	ld		hl,AppFormLists				;* Start of each Forms Data
	add		hl,de						;* HL = HL + (DE*2)
	add		hl,de						;
	ld		e,(hl)						;* DE = Address of Form Data
	inc 	hl
	ld		d,(hl)
	ld		(Sys_Temp1),de				;* Store the Base Address Temporarily

	ld		l,b							;* HL = Object
	ld		h,0
	add		hl,hl
	add		hl,hl
	add		hl,hl
	add		hl,hl
	add		hl,de
	inc		hl
	inc		hl							;* HL = Address of Type / Visibility Byte of Object
	ld		c,a
	ld		a,(hl)
	ld		e,a
	And		%01111111
	Or		c
	cp		e
	ret		z
	ld		(hl),a
	ld		a,b
	Call	Sys_Redraw_All
	ret

;**** System Routines ****
.Sys_Redraw_All:
	ld		a,-1
	ld		(AppMsgB+2),a		
	ld		a,MSC_DSK_WINDIN
	ld		(AppMsgB+0),a
	ld		a,(V_App_OS_Form)
	ld		(AppMsgB+1),a
	ld		iy,AppMsgB
	rst 	#10
	ret
;**** System Routines ****
.Sys_Redraw_Object:
	ld		(AppMsgB+2),a		
	ld		a,MSC_DSK_WINDIN
	ld		(AppMsgB+0),a
	ld		a,(V_App_OS_Form)
	ld		(AppMsgB+1),a
	ld		iy,AppMsgB
	rst 	#10
	ret
;**** Code called on event occuring on Button1
FUNCTION Button1_Event
	//Description:
	//What happens when button is clicked
	//In:
	//-
	//Out:
	//(Nothing)
	//Destroyed:
	//Everything is destroyed
	ld	a,(Count1)
	inc	a
	and	%11
	ld	(Count1),a
	ld	hl,MyTextList
	add	a
	ld	e,a
	ld	d,0
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	hl,Button1_Text
	Call	syStr_Copy
	Call	Sys_Redraw_All
	ret
.Count1
	db	0
.MyTextList
	dw	MyText1,MyText2,MyText3,MyText4
.MyText1
	db 	"This",0
.MyText2
	db	"Text",0
.MyText3
	db	"Keeps",0
.MyText4
	db	"Cycling",0
ENDF
;****
;**** Code called on event occuring on Button2
FUNCTION Button2_Event
	ld	a,(AppPrzN)
	ld	de,Form2
	call SyDesktop_WINOPN
ENDF
;****
;**** Code called on event occuring on Tab1
FUNCTION Tab1_Event

ENDF
;****
;**** Code called on event occuring on Radio1
FUNCTION Radio1_Event

ENDF
;****
;**** Code called on event occuring on Radio2
FUNCTION Radio2_Event

ENDF
;****
;**** Code called on event occuring on Radio3
FUNCTION Radio3_Event

ENDF
;****



;**********************
;**** Data Section ****
;**********************
.AppDatBeg
.AppFormLists
    dw Form1_ControlWindowData
Frm0_Menu_1   db  "File",0
Frm0_Menu_2   db  "Open",0
Frm0_Menu_5   db  "Save",0
Frm0_Menu_3   db  "Edit",0
Frm0_Menu_4   db  "Cut",0
Frm0_Menu_7   db  "Copy",0
Frm0_Menu_6   db  "Paste",0
.ImageBox1_GraphicData:         
    db  32,127,79
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#FD,#F7,#FD,#F7
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#11,#FF,#FF,#FF,#CF
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#33,#FD,#FF,#FF,#EF
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#17,#FF,#7F,#FF,#4E
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#08,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#BF,#F7,#FF,#FF,#CE
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#7F,#FF,#FF,#FF,#CC
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#8E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#FF,#FF,#FF,#FF,#8C
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0F,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#FF,#5F,#FF,#FF,#08
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#8E,#2F,#08,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#3F,#E7,#FF,#FF,#F5,#08
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#7F,#DF,#7F,#FA,#FB,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#01,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#FF,#AF,#FD,#FD,#ED,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0C,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#FF,#5F,#FF,#FF,#CE,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#08,#01,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#FF,#FF,#F7,#F7,#C6,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0C,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#FF,#FF,#FF,#FF,#8C,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#08,#01,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#11,#FF,#FD,#FF,#FF,#88,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#00,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#11,#DF,#FF,#FF,#FF,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#08,#00,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#F7,#FF,#FF,#EE,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#08,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#DF,#7F,#7F,#CC,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#08,#00,#8E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#33,#BF,#BF,#FF,#8C,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#00,#00,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#37,#8F,#0F,#7F,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#23,#08,#00,#8E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#35,#CE,#0A,#0E,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#07,#00,#00,#4C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#77,#4C,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#27,#02,#00,#0E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#7D,#8C,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#05,#05,#00,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#7F,#0D,#04,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0B,#8F,#08,#8E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#ED,#FF,#EE,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#0F,#0C,#4C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#DF,#7F,#4C,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#07,#0F,#0F,#0A,#0E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#EF,#3F,#88,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0F,#0F,#07,#05,#04,#00,#00,#00,#00,#00,#00,#00,#00,#01,#7F,#FF,#5F,#08,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#8F,#2F,#0F,#0E,#00,#00,#00,#00,#00,#00,#00,#03,#BF,#FD,#FD,#E5,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#4F,#0F,#1F,#0D,#0C,#00,#00,#00,#00,#00,#00,#00,#17,#DF,#FF,#FE,#EB,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#8F,#0F,#BF,#8F,#0F,#08,#00,#00,#00,#00,#00,#0B,#FF,#FF,#FD,#F5,#E6,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#0D,#1F,#0F,#0F,#00,#00,#00,#00,#00,#05,#5F,#5F,#FF,#FF,#FA,#C8,#00,#00,#00,#00,#00
    db  #08,#00,#00,#00,#00,#00,#00,#00,#00,#03,#2F,#0A,#0F,#AF,#CF,#08,#00,#00,#00,#0B,#1F,#F7,#FF,#FF,#FF,#F1,#84,#00,#08,#00,#08,#00
    db  #04,#00,#00,#00,#00,#00,#00,#00,#00,#07,#4F,#05,#05,#4F,#4F,#0C,#00,#01,#17,#4F,#1D,#CF,#FF,#DF,#FA,#FB,#00,#00,#00,#00,#00,#00
    db  #0A,#0A,#00,#00,#00,#00,#00,#00,#00,#27,#CF,#0A,#0F,#2F,#EF,#0E,#00,#13,#ED,#6F,#3F,#3F,#FF,#F5,#F5,#E6,#00,#00,#00,#02,#00,#00
    db  #05,#05,#00,#00,#00,#00,#00,#00,#00,#17,#0F,#05,#0D,#0F,#7F,#0E,#01,#1F,#FF,#DF,#7F,#7E,#5F,#FE,#FF,#0C,#00,#00,#00,#00,#00,#00
    db  #0E,#0E,#0E,#0A,#08,#00,#00,#00,#00,#0F,#8F,#0F,#2F,#AF,#EF,#CF,#3F,#F5,#C7,#FF,#FD,#F5,#FD,#F1,#E1,#88,#00,#08,#08,#08,#00,#08
    db  #05,#05,#05,#05,#04,#00,#00,#00,#01,#5F,#CF,#07,#7F,#0F,#0F,#4F,#5F,#FB,#CF,#7F,#FB,#FB,#FA,#CD,#FB,#08,#00,#00,#00,#00,#00,#00
    db  #0F,#0B,#0A,#0A,#0A,#0A,#00,#00,#02,#AF,#8F,#0F,#AF,#2F,#2F,#0F,#7D,#F7,#EF,#FF,#F4,#F4,#F7,#09,#F7,#08,#00,#00,#02,#00,#02,#00
    db  #0F,#0F,#05,#05,#05,#05,#04,#00,#01,#5F,#4F,#0F,#0F,#07,#1F,#0F,#7E,#FB,#7F,#FE,#FA,#FA,#8C,#11,#DF,#00,#00,#00,#00,#00,#00,#00
    db  #8F,#8F,#0F,#0E,#0E,#0E,#0E,#0A,#0B,#EF,#FF,#8F,#0E,#0F,#2F,#AF,#BC,#E1,#FF,#FC,#F0,#E3,#08,#13,#E7,#00,#08,#08,#08,#00,#08,#08
    db  #4F,#0F,#0F,#0F,#0D,#05,#05,#05,#05,#DF,#FF,#CD,#05,#07,#0F,#7F,#7E,#FB,#FB,#FE,#F2,#DF,#00,#13,#CF,#00,#00,#00,#00,#00,#00,#00
    db  #FF,#AF,#AF,#AF,#0F,#0F,#0A,#0B,#0B,#EF,#E7,#8E,#0B,#0F,#0F,#FD,#FE,#F5,#F1,#F5,#F1,#D7,#8C,#33,#AE,#00,#02,#00,#00,#02,#00,#00
    db  #07,#5F,#5F,#0F,#0F,#0F,#0D,#05,#05,#DF,#FB,#0F,#07,#07,#0F,#7F,#FF,#FA,#FA,#FA,#FA,#FB,#CC,#32,#4E,#00,#00,#00,#00,#00,#00,#00
    db  #0A,#0F,#BF,#EF,#AF,#AF,#AF,#0F,#0F,#EF,#E1,#0E,#0F,#0F,#2F,#FF,#E7,#FD,#F4,#F7,#F1,#F1,#E7,#3D,#CE,#00,#08,#08,#00,#08,#08,#08
    db  #05,#05,#05,#1F,#DF,#5F,#4F,#4F,#0F,#DF,#FB,#0F,#0D,#0F,#0F,#FF,#CF,#7F,#FA,#FB,#FA,#FA,#FB,#7F,#4C,#00,#00,#00,#00,#00,#00,#00
    db  #0A,#0B,#0A,#0B,#BF,#FF,#AF,#AF,#AF,#EF,#F5,#8F,#0F,#8F,#0F,#FF,#AF,#3F,#FD,#FF,#FD,#F7,#F5,#BD,#8C,#00,#02,#00,#00,#00,#00,#02
    db  #01,#05,#05,#05,#05,#17,#7F,#5F,#0F,#7F,#FB,#8F,#5F,#0F,#5F,#1F,#4F,#1F,#FE,#FB,#FE,#FB,#FE,#DF,#8C,#00,#00,#00,#00,#00,#00,#00
    db  #0A,#0E,#0E,#0F,#0E,#0F,#0F,#FF,#EF,#FF,#FD,#E3,#EF,#8F,#FF,#AF,#AF,#8F,#FD,#F1,#FC,#F1,#F5,#E3,#88,#00,#08,#08,#08,#08,#08,#08
    db  #05,#05,#05,#05,#0D,#05,#0D,#07,#7F,#7F,#FF,#FB,#0F,#0F,#5F,#5F,#4F,#0F,#7A,#FB,#FE,#FA,#FB,#FB,#08,#00,#00,#00,#00,#00,#00,#00
    db  #0B,#0B,#0B,#0B,#0B,#0F,#0F,#0F,#0F,#3F,#FD,#FC,#C7,#3F,#AF,#BF,#AF,#2F,#3D,#F4,#F7,#F4,#F5,#F5,#8C,#00,#02,#02,#02,#00,#02,#02
    db  #05,#05,#05,#05,#05,#05,#05,#05,#05,#17,#7F,#FA,#EF,#7E,#FF,#5F,#0F,#0F,#3E,#FF,#FF,#FE,#FA,#FA,#CC,#00,#00,#00,#00,#00,#00,#00
    db  #0F,#0F,#0F,#0F,#0B,#0F,#0F,#0F,#0F,#0F,#EF,#F1,#F7,#F1,#F7,#EF,#8F,#AF,#9F,#F7,#F1,#F0,#F0,#F1,#E7,#08,#08,#08,#08,#08,#08,#08
    db  #0F,#0F,#0D,#0D,#05,#0D,#0D,#0D,#0D,#1F,#1F,#FB,#5F,#FB,#FB,#4F,#4F,#0F,#0F,#FA,#FA,#FA,#F2,#F2,#FA,#88,#00,#00,#00,#00,#00,#00
    db  #0B,#0F,#0F,#0F,#0B,#0F,#0F,#0F,#0F,#0F,#0F,#EF,#3F,#F5,#F0,#AF,#AF,#AF,#0F,#F8,#F7,#F0,#F0,#F0,#F4,#88,#02,#02,#02,#02,#02,#02
    db  #00,#01,#07,#0F,#07,#0F,#07,#07,#05,#05,#05,#0F,#1E,#FE,#FA,#FB,#0F,#0F,#0F,#7A,#FF,#FA,#F8,#FA,#FA,#08,#00,#00,#00,#00,#00,#00
    db  #0E,#0E,#0A,#0B,#0F,#8F,#0F,#0F,#0F,#0F,#0F,#0F,#3F,#ED,#3F,#F8,#AF,#AF,#AF,#7C,#F0,#F0,#F0,#F0,#F1,#88,#08,#0A,#0A,#08,#08,#08
    db  #05,#05,#05,#05,#0D,#0F,#0F,#0F,#0D,#0F,#0D,#0D,#3F,#CE,#0F,#7E,#C7,#4F,#4F,#3E,#F2,#F2,#F2,#F2,#FA,#08,#00,#00,#00,#00,#00,#00
    db  #0F,#0F,#0F,#0F,#0A,#0A,#0F,#2F,#0F,#0F,#0F,#0F,#3F,#8B,#0F,#3F,#E3,#2F,#AF,#3C,#F0,#F0,#F0,#F0,#F4,#8A,#02,#02,#02,#02,#02,#02
    db  #05,#07,#07,#07,#05,#05,#05,#05,#17,#0F,#0F,#0F,#37,#01,#07,#1F,#7D,#0F,#5F,#1E,#FE,#F8,#FA,#F8,#FA,#08,#00,#00,#00,#00,#00,#00
    db  #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#8F,#0F,#AF,#8F,#2F,#0F,#0F,#8F,#FF,#87,#AF,#FE,#F4,#F0,#F1,#F0,#F0,#88,#08,#08,#08,#0A,#08,#08
    db  #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0D,#05,#07,#4F,#6F,#0D,#07,#0F,#1F,#EB,#1F,#FA,#F2,#F2,#FA,#FA,#FA,#88,#00,#00,#00,#00,#00,#00
    db  #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#2D,#0F,#0F,#0F,#2F,#FC,#F4,#F0,#F0,#F0,#F4,#F1,#F4,#88,#00,#02,#02,#02,#02,#02
    db  #0F,#0F,#0F,#0F,#07,#0F,#0F,#0F,#07,#0F,#0F,#17,#2F,#05,#07,#0F,#1F,#7E,#FA,#F8,#F8,#F8,#FA,#FA,#FA,#88,#00,#00,#00,#00,#00,#00
    db  #AF,#8F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#8F,#8F,#0F,#2F,#0F,#0F,#0F,#0F,#FF,#F0,#F0,#F0,#F0,#F0,#F1,#F0,#88,#08,#08,#0A,#0A,#0A,#0A
    db  #0F,#4F,#4F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#6F,#0D,#0F,#0F,#0F,#5F,#F8,#F0,#F0,#F0,#F2,#FA,#F2,#88,#00,#00,#00,#00,#00,#00
    db  #AF,#AF,#AF,#AF,#AF,#8F,#0F,#2F,#2F,#2F,#AF,#AF,#3D,#0F,#0F,#2F,#0F,#3F,#FC,#F0,#F0,#F0,#F0,#F0,#F0,#88,#00,#02,#02,#02,#02,#02
    db  #0F,#1F,#1F,#1F,#5F,#5F,#0F,#0F,#0F,#1F,#1F,#4F,#7F,#0F,#0F,#0F,#4F,#1F,#7F,#F8,#FA,#FA,#F8,#FA,#F8,#88,#00,#00,#00,#00,#00,#00
    db  #AF,#AF,#AF,#AF,#AF,#FF,#FF,#EF,#AF,#0F,#AF,#EF,#FD,#8F,#0F,#0F,#6F,#AF,#FF,#F0,#F0,#F0,#F0,#F0,#F0,#80,#08,#0A,#0A,#0A,#0A,#0A
    db  #4F,#4F,#5F,#5F,#5F,#5F,#5F,#DF,#FF,#DF,#0F,#0F,#7A,#CF,#0F,#0F,#3F,#5F,#5F,#FE,#F0,#F2,#F2,#F2,#F2,#88,#00,#00,#00,#00,#00,#00
    db  #BF,#AF,#AF,#AF,#AF,#BF,#BF,#FF,#FF,#FF,#FF,#FF,#FC,#E7,#0F,#0F,#3F,#EF,#BF,#FF,#F0,#F0,#F5,#F4,#F0,#88,#02,#02,#02,#02,#02,#02
    db  #05,#1F,#FF,#5F,#5F,#5F,#5F,#7F,#7F,#FF,#FF,#FF,#FE,#EB,#0F,#0F,#1F,#FF,#5F,#7F,#FA,#FB,#0F,#1F,#F8,#88,#00,#00,#00,#00,#00,#00
    db  #00,#08,#7F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F7,#F5,#E1,#0F,#0F,#0F,#FF,#EF,#FF,#FF,#AF,#0F,#0F,#3E,#80,#0A,#0A,#0A,#0A,#0A,#0A
    db  #0D,#00,#7F,#FF,#FB,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FA,#FF,#0F,#0F,#0F,#7F,#DF,#5F,#4F,#0F,#0F,#0F,#1E,#88,#00,#00,#00,#00,#00,#00
    db  #2F,#AF,#3F,#FD,#F5,#F5,#BF,#FD,#FF,#FF,#FF,#FF,#FF,#F4,#0F,#2F,#0F,#FD,#FF,#AF,#0F,#0F,#0F,#0F,#1F,#80,#02,#02,#02,#02,#02,#02
    db  #0F,#0F,#1F,#7F,#FF,#FF,#5F,#FA,#FA,#FF,#FF,#FF,#FF,#FC,#8F,#0F,#0F,#7E,#0F,#0F,#0F,#0F,#0F,#0F,#1F,#88,#00,#00,#00,#00,#00,#00
    db  #AF,#AF,#AF,#AF,#BF,#FF,#FF,#FC,#F0,#F0,#F0,#F1,#F1,#F8,#87,#2F,#AF,#AF,#0F,#0F,#0F,#0F,#0F,#0F,#1F,#80,#0A,#0A,#0A,#0A,#0A,#0A
    db  #0F,#0F,#0F,#4F,#4F,#5F,#5F,#FF,#FA,#F2,#F0,#F2,#F3,#78,#C7,#0F,#4F,#0F,#0F,#0D,#0F,#0F,#0F,#0F,#1F,#8C,#00,#00,#00,#00,#00,#00
    db  #2F,#AF,#AF,#AF,#AF,#AF,#AF,#BF,#FF,#FF,#F4,#F0,#F5,#FC,#E7,#2F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#2F,#3F,#82,#02,#02,#02,#02,#0A,#0A
;**** Form Icon ***
.Form1_Icon:
        db 2,8,8
    db  #FF,#FF,#88,#11,#B8,#D1,#88,#51,#BC,#D3,#AD,#5B,#8F,#1F,#FF,#FF
.Form1_Caption:                 db "Demo form",0
.Form1_StatusCaption:           db "Just shows use of objects",0
.Tab1_TextMaxLen1:              db  6
.Tab1_Text1:                    db  "Checks",0
.Tab1_TextMaxLen2:              db  8
.Tab1_Text2:                    db  "Graphics",0
.Tab1_TextMaxLen3:              db  4
.Tab1_Text3:                    db  "Text",0
.Check1_TextMaxLen:             db  15
.Check1_Text:                   db  "Keeping Details",0
.Frame1_TextMaxLen:             db  16
.Frame1_Text:                   db  "Personal Details",0
.Label1_TextMaxLen:             db  5
.Label1_Text:                   db  "Name:",0
.Label2_TextMaxLen:             db  4
.Label2_Text:                   db  "Age:",0
;**** Object (ImageBox1) Extra Data Record ****
.ImageBox1_ExtData:             
.ImageBox1_Addr:                db  6,24,24
   ds  24*6
.Label3_TextMaxLen:             db  16
.Label3_Text:                   db  "Just Random Text",0
.Button1_TextMaxLen:            db  10
.Button1_ExtData:               
.Button1_Text:                  db  "Click": ds 5,0
.Button2_TextMaxLen:            db  4
.Button2_ExtData:               
.Button2_Text:                  db  "This",0
.Radio1_TextMaxLen:             db  3
.Radio1_Text:                   db  "One",0
.Radio2_TextMaxLen:             db  3
.Radio2_Text:                   db  "Two",0
.Radio3_TextMaxLen:             db  5
.Radio3_Text:                   db  "Three",0
.ImageBox2_GraphicData:         
    db  32,128,53
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#FD,#F7,#FD,#F7
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#11,#FF,#FF,#FF,#CF
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#33,#FD,#FF,#FF,#EF
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#17,#FF,#7F,#FF,#4E
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#08,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#BF,#F7,#FF,#FF,#CE
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#7F,#FF,#FF,#FF,#CC
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#8E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#FF,#FF,#FF,#FF,#8C
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0F,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#FF,#5F,#FF,#FF,#08
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#8E,#2F,#08,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#3F,#E7,#FF,#FF,#F5,#08
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#7F,#DF,#7F,#FA,#FB,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#01,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#FF,#AF,#FD,#FD,#ED,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0C,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#FF,#5F,#FF,#FF,#CE,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#08,#01,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#FF,#FF,#F7,#F7,#C6,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0C,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#FF,#FF,#FF,#FF,#8C,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#08,#01,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#11,#FF,#FD,#FF,#FF,#88,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#00,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#11,#DF,#FF,#FF,#FF,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#08,#00,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#F7,#FF,#FF,#EE,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#08,#01,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#DF,#7F,#7F,#CC,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#08,#00,#8E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#33,#BF,#BF,#FF,#8C,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#00,#00,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#37,#8F,#0F,#7F,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#23,#08,#00,#8E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#35,#CE,#0A,#0E,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#07,#00,#00,#4C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#77,#4C,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#27,#02,#00,#0E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#7D,#8C,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#05,#05,#00,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#7F,#0D,#04,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0B,#8F,#08,#8E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#ED,#FF,#EE,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#0F,#0C,#4C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#DF,#7F,#4C,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#07,#0F,#0F,#0A,#0E,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#EF,#3F,#88,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0F,#0F,#07,#05,#04,#00,#00,#00,#00,#00,#00,#00,#00,#01,#7F,#FF,#5F,#08,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#8F,#2F,#0F,#0E,#00,#00,#00,#00,#00,#00,#00,#03,#BF,#FD,#FD,#E5,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#4F,#0F,#1F,#0D,#0C,#00,#00,#00,#00,#00,#00,#00,#17,#DF,#FF,#FE,#EB,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#8F,#0F,#BF,#8F,#0F,#08,#00,#00,#00,#00,#00,#0B,#FF,#FF,#FD,#F5,#E6,#00,#00,#00,#00,#00
    db  #00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#0D,#1F,#0F,#0F,#00,#00,#00,#00,#00,#05,#5F,#5F,#FF,#FF,#FA,#C8,#00,#00,#00,#00,#00
    db  #08,#00,#00,#00,#00,#00,#00,#00,#00,#03,#2F,#0A,#0F,#AF,#CF,#08,#00,#00,#00,#0B,#1F,#F7,#FF,#FF,#FF,#F1,#84,#00,#08,#00,#08,#00
    db  #04,#00,#00,#00,#00,#00,#00,#00,#00,#07,#4F,#05,#05,#4F,#4F,#0C,#00,#01,#17,#4F,#1D,#CF,#FF,#DF,#FA,#FB,#00,#00,#00,#00,#00,#00
    db  #0A,#0A,#00,#00,#00,#00,#00,#00,#00,#27,#CF,#0A,#0F,#2F,#EF,#0E,#00,#13,#ED,#6F,#3F,#3F,#FF,#F5,#F5,#E6,#00,#00,#00,#02,#00,#00
    db  #05,#05,#00,#00,#00,#00,#00,#00,#00,#17,#0F,#05,#0D,#0F,#7F,#0E,#01,#1F,#FF,#DF,#7F,#7E,#5F,#FE,#FF,#0C,#00,#00,#00,#00,#00,#00
    db  #0E,#0E,#0E,#0A,#08,#00,#00,#00,#00,#0F,#8F,#0F,#2F,#AF,#EF,#CF,#3F,#F5,#C7,#FF,#FD,#F5,#FD,#F1,#E1,#88,#00,#08,#08,#08,#00,#08
    db  #05,#05,#05,#05,#04,#00,#00,#00,#01,#5F,#CF,#07,#7F,#0F,#0F,#4F,#5F,#FB,#CF,#7F,#FB,#FB,#FA,#CD,#FB,#08,#00,#00,#00,#00,#00,#00
    db  #0F,#0B,#0A,#0A,#0A,#0A,#00,#00,#02,#AF,#8F,#0F,#AF,#2F,#2F,#0F,#7D,#F7,#EF,#FF,#F4,#F4,#F7,#09,#F7,#08,#00,#00,#02,#00,#02,#00
    db  #0F,#0F,#05,#05,#05,#05,#04,#00,#01,#5F,#4F,#0F,#0F,#07,#1F,#0F,#7E,#FB,#7F,#FE,#FA,#FA,#8C,#11,#DF,#00,#00,#00,#00,#00,#00,#00
    db  #8F,#8F,#0F,#0E,#0E,#0E,#0E,#0A,#0B,#EF,#FF,#8F,#0E,#0F,#2F,#AF,#BC,#E1,#FF,#FC,#F0,#E3,#08,#13,#E7,#00,#08,#08,#08,#00,#08,#08
    db  #4F,#0F,#0F,#0F,#0D,#05,#05,#05,#05,#DF,#FF,#CD,#05,#07,#0F,#7F,#7E,#FB,#FB,#FE,#F2,#DF,#00,#13,#CF,#00,#00,#00,#00,#00,#00,#00
    db  #FF,#AF,#AF,#AF,#0F,#0F,#0A,#0B,#0B,#EF,#E7,#8E,#0B,#0F,#0F,#FD,#FE,#F5,#F1,#F5,#F1,#D7,#8C,#33,#AE,#00,#02,#00,#00,#02,#00,#00
    db  #07,#5F,#5F,#0F,#0F,#0F,#0D,#05,#05,#DF,#FB,#0F,#07,#07,#0F,#7F,#FF,#FA,#FA,#FA,#FA,#FB,#CC,#32,#4E,#00,#00,#00,#00,#00,#00,#00
    db  #0A,#0F,#BF,#EF,#AF,#AF,#AF,#0F,#0F,#EF,#E1,#0E,#0F,#0F,#2F,#FF,#E7,#FD,#F4,#F7,#F1,#F1,#E7,#3D,#CE,#00,#08,#08,#00,#08,#08,#08
    db  #05,#05,#05,#1F,#DF,#5F,#4F,#4F,#0F,#DF,#FB,#0F,#0D,#0F,#0F,#FF,#CF,#7F,#FA,#FB,#FA,#FA,#FB,#7F,#4C,#00,#00,#00,#00,#00,#00,#00
    db  #0A,#0B,#0A,#0B,#BF,#FF,#AF,#AF,#AF,#EF,#F5,#8F,#0F,#8F,#0F,#FF,#AF,#3F,#FD,#FF,#FD,#F7,#F5,#BD,#8C,#00,#02,#00,#00,#00,#00,#02
    db  #01,#05,#05,#05,#05,#17,#7F,#5F,#0F,#7F,#FB,#8F,#5F,#0F,#5F,#1F,#4F,#1F,#FE,#FB,#FE,#FB,#FE,#DF,#8C,#00,#00,#00,#00,#00,#00,#00
    db  #0A,#0E,#0E,#0F,#0E,#0F,#0F,#FF,#EF,#FF,#FD,#E3,#EF,#8F,#FF,#AF,#AF,#8F,#FD,#F1,#FC,#F1,#F5,#E3,#88,#00,#08,#08,#08,#08,#08,#08
    db  #05,#05,#05,#05,#0D,#05,#0D,#07,#7F,#7F,#FF,#FB,#0F,#0F,#5F,#5F,#4F,#0F,#7A,#FB,#FE,#FA,#FB,#FB,#08,#00,#00,#00,#00,#00,#00,#00
    db  #0B,#0B,#0B,#0B,#0B,#0F,#0F,#0F,#0F,#3F,#FD,#FC,#C7,#3F,#AF,#BF,#AF,#2F,#3D,#F4,#F7,#F4,#F5,#F5,#8C,#00,#02,#02,#02,#00,#02,#02
    db  #05,#05,#05,#05,#05,#05,#05,#05,#05,#17,#7F,#FA,#EF,#7E,#FF,#5F,#0F,#0F,#3E,#FF,#FF,#FE,#FA,#FA,#CC,#00,#00,#00,#00,#00,#00,#00
    db  #0F,#0F,#0F,#0F,#0B,#0F,#0F,#0F,#0F,#0F,#EF,#F1,#F7,#F1,#F7,#EF,#8F,#AF,#9F,#F7,#F1,#F0,#F0,#F1,#E7,#08,#08,#08,#08,#08,#08,#08
;**** Form Icon ***
.Form2_Icon:
        db 2,8,8
    db 0,0,0,0,0,0,0,0
.Form2_Caption:                 db "Hello",0
.Form2_StatusCaption:           db "",0
.Button3_TextMaxLen:            db  7
.Button3_ExtData:               
.Button3_Text:                  db  "Button3",0
.Button4_TextMaxLen:            db  7
.Button4_ExtData:               
.Button4_Text:                  db  "Button4",0
.Button5_TextMaxLen:            db  7
.Button5_ExtData:               
.Button5_Text:                  db  "Button5",0
;**** Object (ImageBox2) Extra Data Record ****
.ImageBox2_ExtData:             
.ImageBox2_Addr:                db  6,24,24
   ds  24*6


;**************************
;**** Transfer Section ****
;**************************
.AppTrnBeg
          ds    128
.AppStk   ds    6*2
          dw    AppPrz
.AppPrzN  db    0
.AppMsgB  ds    14

.App_Form_List
     dw  Form1,Form2
;***
;**** Z80 version of Form Form1 ***
;***
.Form1
.Form1_Status:                  db 1
.Form1_Display:                 db 117
.Form1_SizeAdjust:              db 0
.Form1_OwnerID:                 db 0
.Form1_Left:                    dw 0
.Form1_Top:                     dw 0
.Form1_Width:                   dw 222
.Form1_Height:                  dw 116
.Form1_OffsetWidth:             dw 1
.Form1_OffsetHeight:            dw 8
.Form1_ContentWidth:            dw 213
.Form1_ContentHeight:           dw 115
.Form1_MinWidth:                dw 0
.Form1_MinHeight:               dw 0
.Form1_MaxWidth:                dw 320
.Form1_MaxHeight:               dw 192
.Form1_IconAddr:                dw Form1_Icon
.Form1_CaptionAddr:             dw Form1_Caption
.Form1_StatusAddr:              dw Form1_StatusCaption
.Form1_MenuAddr:                dw Form1_Menu
.Form1_ControlWindowAddr:       dw Form1_ControlWindow
.Form1_ControlToolAddr:         dw 0 ;Form1_ControlTool
.Form1_ToolBarHeight:           dw 8
     ds 136+14
.Form1_Menu:                    
.Form1_MenuData1:               dw 2
        dw  5,Frm0_Menu_1,Form1_MenuData2,0
        dw  5,Frm0_Menu_3,Form1_MenuData3,0
.Form1_MenuData2:               dw 2
        dw  1,Frm0_Menu_2,0,0
        dw  1,Frm0_Menu_5,0,0
.Form1_MenuData3:               dw 3
        dw  1,Frm0_Menu_4,0,0
        dw  1,Frm0_Menu_7,0,0
        dw  1,Frm0_Menu_6,0,0
;****
;**** Data Control Record (ControlWindow) ****
;****
.Form1_ControlWindow:           
.Form1_ControlWindowCount:      db 17
.Form1_ControlWindowOwnerID:    db 0
.Form1_ControlWindowDataAddr:   dw Form1_ControlWindowData
.Form1_ControlWindowCalcAddr:   dw 0; Form1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlWindowFocus:      db 0
     db 0
;****
.Form1_ControlWindowData:       
;**** OBject Window Background Data Record ****
dw 0,255*256+0,          2,  0,0,1000,1000,0
;**** Object (Fr_Tab1) Data Record ****
.Fr_Tab1_ID:                    dw 1
.Fr_Tab1_Type:                  db 2   ;* Frame
.Fr_Tab1_ExtDataBank:           db 255
.Fr_Tab1_Appearance:            db  101,0
.Fr_Tab1_Left:                  dw 66
.Fr_Tab1_Top:                   dw 16
.Fr_Tab1_Width:                 dw 143
.Fr_Tab1_Height:                dw 93
.Fr_Tab1_Code:                  dw 0
;**** Object (Tab1) Data Record ****
.Tab1_ID:                       dw 2
.Tab1_Type:                     db 20   ;* 
.Tab1_ExtDataBank:              db 255
.Tab1_ExtDataAddr:              dw Tab1_ExtData
.Tab1_Left:                     dw 66
.Tab1_Top:                      dw 6
.Tab1_Width:                    dw 143
.Tab1_Height:                   dw 10
.Tab1_Code:                     dw Tab1_Event
;**** Object (Check1) Data Record ****
.Check1_ID:                     dw 259
.Check1_Type:                   db 145   ;* 
.Check1_ExtDataBank:            db 255
.Check1_ExtDataAddr:            dw Check1_ExtData
.Check1_Left:                   dw 77
.Check1_Top:                    dw 25
.Check1_Width:                  dw 80
.Check1_Height:                 dw 9
.Check1_Code:                   dw 0
;**** Object (Frame1) Data Record ****
.Frame1_ID:                     dw 260
.Frame1_Type:                   db 131   ;* Button
.Frame1_ExtDataBank:            db 255
.Frame1_ExtDataAddr:            dw Frame1_ExtData
.Frame1_Left:                   dw 73
.Frame1_Top:                    dw 38
.Frame1_Width:                  dw 131
.Frame1_Height:                 dw 66
.Frame1_Code:                   dw 0
;**** Object (TextLine1) Data Record ****
.TextLine1_ID:                  dw 261
.TextLine1_Type:                db 32   ;* 
.TextLine1_ExtDataBank:         db 255
.TextLine1_ExtDataAddr:         dw TextLine1_ExtData
.TextLine1_Left:                dw 83
.TextLine1_Top:                 dw 60
.TextLine1_Width:               dw 111
.TextLine1_Height:              dw 10
.TextLine1_Code:                dw 0
;**** Object (Label1) Data Record ****
.Label1_ID:                     dw 262
.Label1_Type:                   db 1   ;* Form
.Label1_ExtDataBank:            db 255
.Label1_ExtDataAddr:            dw Label1_ExtData
.Label1_Left:                   dw 84
.Label1_Top:                    dw 50
.Label1_Width:                  dw 50
.Label1_Height:                 dw 8
.Label1_Code:                   dw 0
;**** Object (TextLine2) Data Record ****
.TextLine2_ID:                  dw 263
.TextLine2_Type:                db 32   ;* 
.TextLine2_ExtDataBank:         db 255
.TextLine2_ExtDataAddr:         dw TextLine2_ExtData
.TextLine2_Left:                dw 84
.TextLine2_Top:                 dw 84
.TextLine2_Width:               dw 33
.TextLine2_Height:              dw 11
.TextLine2_Code:                dw 0
;**** Object (Label2) Data Record ****
.Label2_ID:                     dw 264
.Label2_Type:                   db 1   ;* Form
.Label2_ExtDataBank:            db 255
.Label2_ExtDataAddr:            dw Label2_ExtData
.Label2_Left:                   dw 85
.Label2_Top:                    dw 76
.Label2_Width:                  dw 50
.Label2_Height:                 dw 8
.Label2_Code:                   dw 0
;**** Object (ImageBox1) Data Record ****
.ImageBox1_ID:                  dw 521
.ImageBox1_Type:                db 8   ;* VSpinner
.ImageBox1_ExtDataBank:         db 255
.ImageBox1_GraphicAddr:         dw ImageBox1_GraphicData
.ImageBox1_Left:                dw 74
.ImageBox1_Top:                 dw 23
.ImageBox1_Width:               dw 127
.ImageBox1_Height:              dw 79
.ImageBox1_Code:                dw 0
;**** Object (Label3) Data Record ****
.Label3_ID:                     dw 778
.Label3_Type:                   db 129   ;* Form
.Label3_ExtDataBank:            db 255
.Label3_ExtDataAddr:            dw Label3_ExtData
.Label3_Left:                   dw 74
.Label3_Top:                    dw 25
.Label3_Width:                  dw 126
.Label3_Height:                 dw 8
.Label3_Code:                   dw 0
;**** Object (Box1) Data Record ****
.Box1_ID:                       dw 779
.Box1_Type:                     db 130   ;* Frame
.Box1_ExtDataBank:              db 255
.Box1_Appearance:               db  80,0
.Box1_Left:                     dw 74
.Box1_Top:                      dw 39
.Box1_Width:                    dw 128
.Box1_Height:                   dw 63
.Box1_Code:                     dw 0
;**** Object (Button1) Data Record ****
.Button1_ID:                    dw 12
.Button1_Type:                  db 16   ;* Paint
.Button1_ExtDataBank:           db 255
.Button1_ExtDataAddr:           dw Button1_ExtData
.Button1_Left:                  dw 7
.Button1_Top:                   dw 7
.Button1_Width:                 dw 50
.Button1_Height:                dw 11
.Button1_Code:                  dw Button1_Event
;**** Object (Button2) Data Record ****
.Button2_ID:                    dw 13
.Button2_Type:                  db 16   ;* Paint
.Button2_ExtDataBank:           db 255
.Button2_ExtDataAddr:           dw Button2_ExtData
.Button2_Left:                  dw 7
.Button2_Top:                   dw 23
.Button2_Width:                 dw 50
.Button2_Height:                dw 11
.Button2_Code:                  dw Button2_Event
;**** Object (Radio1) Data Record ****
.Radio1_ID:                     dw 14
.Radio1_Type:                   db 18   ;* 
.Radio1_ExtDataBank:            db 255
.Radio1_ExtDataAddr:            dw Radio1_ExtData
.Radio1_Left:                   dw 8
.Radio1_Top:                    dw 48
.Radio1_Width:                  dw 50
.Radio1_Height:                 dw 8
.Radio1_Code:                   dw Radio1_Event
;**** Object (Radio2) Data Record ****
.Radio2_ID:                     dw 15
.Radio2_Type:                   db 18   ;* 
.Radio2_ExtDataBank:            db 255
.Radio2_ExtDataAddr:            dw Radio2_ExtData
.Radio2_Left:                   dw 8
.Radio2_Top:                    dw 57
.Radio2_Width:                  dw 50
.Radio2_Height:                 dw 8
.Radio2_Code:                   dw Radio2_Event
;**** Object (Radio3) Data Record ****
.Radio3_ID:                     dw 16
.Radio3_Type:                   db 18   ;* 
.Radio3_ExtDataBank:            db 255
.Radio3_ExtDataAddr:            dw Radio3_ExtData
.Radio3_Left:                   dw 8
.Radio3_Top:                    dw 66
.Radio3_Width:                  dw 50
.Radio3_Height:                 dw 8
.Radio3_Code:                   dw Radio3_Event
;**** Object (Tab1) Additional Extra Data Record ****
.Tab1_AdditionalExtData:        
.Tab1_OldValue:                 db  1
.Tab1_Redraw:                   db  1
;**** Object (Tab1) Extra Data Record ****
.Tab1_ExtData:                  
.Tab1_Tabs:                     db  3
.Tab1_Appearance:               db  86
.Tab1_Value:                    db  1
.Tab1_TextAddr1:                dw  Tab1_Text1
.Tab1_TabWidth1:                db -1
.Tab1_TextAddr2:                dw  Tab1_Text2
.Tab1_TabWidth2:                db -1
.Tab1_TextAddr3:                dw  Tab1_Text3
.Tab1_TabWidth3:                db -1
;**** Object (Check1) Extra Data Record ****
.Check1_ExtData:                
.Check1_ValueAddr:              dw  Check1_Value
.Check1_TextAddr:               dw  Check1_Text
.Check1_TextAppearance:         db  6
.Check1_Value:                  db  1
;**** Object (Frame1) Extra Data Record ****
.Frame1_ExtData:                
.Frame1_TextAddr:               dw  Frame1_Text
.Frame1_Appearance:             db  6
;**** Object (TextLine1) Extra Data Record ****
.TextLine1_ExtData:             
.TextLine1_TextAddr:            dw  TextLine1_Text
.TextLine1_FDC:                 dw  0
.TextLine1_CurPos:              dw  0
.TextLine1_Selected:            dw  0
.TextLine1_TextLen:             dw  0
.TextLine1_TextMax:             dw  24
.TextLine1_Flags:               db  0
.TextLine1_Text:                db  "",0
    ds  24
;**** Object (Label1) Extra Data Record ****
.Label1_ExtData:                
.Label1_TextAddr:               dw  Label1_Text
.Label1_TextAppearance:         db  134
.Label1_TextAlignment:          db  0
;**** Object (TextLine2) Extra Data Record ****
.TextLine2_ExtData:             
.TextLine2_TextAddr:            dw  TextLine2_Text
.TextLine2_FDC:                 dw  0
.TextLine2_CurPos:              dw  0
.TextLine2_Selected:            dw  0
.TextLine2_TextLen:             dw  2
.TextLine2_TextMax:             dw  24
.TextLine2_Flags:               db  0
.TextLine2_Text:                db  "20",0
    ds  22
;**** Object (Label2) Extra Data Record ****
.Label2_ExtData:                
.Label2_TextAddr:               dw  Label2_Text
.Label2_TextAppearance:         db  134
.Label2_TextAlignment:          db  0
;**** Object (Label3) Extra Data Record ****
.Label3_ExtData:                
.Label3_TextAddr:               dw  Label3_Text
.Label3_TextAppearance:         db  134
.Label3_TextAlignment:          db  0
;**** Object (Button1) Extra Data Record **** (see in Data Section)
;**** Object (Button2) Extra Data Record **** (see in Data Section)
;**** Object (Radio1) Extra Data Record ****
.Radio1_ExtData:                
.Radio1_GroupStatusAddr:        dw  GroupStatus0
.Radio1_TextAddr:               dw  Radio1_Text
.Radio1_TextAppearance:         db  6
.Radio1_Value:                  db  15
.Radio1_GroupCoordAddr:         dw  GroupCoord0
;**** Object (Radio2) Extra Data Record ****
.Radio2_ExtData:                
.Radio2_GroupStatusAddr:        dw  GroupStatus0
.Radio2_TextAddr:               dw  Radio2_Text
.Radio2_TextAppearance:         db  6
.Radio2_Value:                  db  16
.Radio2_GroupCoordAddr:         dw  GroupCoord0
;**** Object (Radio3) Extra Data Record ****
.Radio3_ExtData:                
.Radio3_GroupStatusAddr:        dw  GroupStatus0
.Radio3_TextAddr:               dw  Radio3_Text
.Radio3_TextAppearance:         db  6
.Radio3_Value:                  db  17
.Radio3_GroupCoordAddr:         dw  GroupCoord0
;***
;**** Z80 version of Form Form2 ***
;***
.Form2
.Form2_Status:                  db 1
.Form2_Display:                 db 84
.Form2_SizeAdjust:              db 0
.Form2_OwnerID:                 db 0
.Form2_Left:                    dw 0
.Form2_Top:                     dw 0
.Form2_Width:                   dw 200
.Form2_Height:                  dw 121
.Form2_OffsetWidth:             dw 1
.Form2_OffsetHeight:            dw 8
.Form2_ContentWidth:            dw 191
.Form2_ContentHeight:           dw 120
.Form2_MinWidth:                dw 0
.Form2_MinHeight:               dw 0
.Form2_MaxWidth:                dw 320
.Form2_MaxHeight:               dw 192
.Form2_IconAddr:                dw Form2_Icon
.Form2_CaptionAddr:             dw Form2_Caption
.Form2_StatusAddr:              dw Form2_StatusCaption
.Form2_MenuAddr:                dw Form2_Menu
.Form2_ControlWindowAddr:       dw Form2_ControlWindow
.Form2_ControlToolAddr:         dw 0 ;Form2_ControlTool
.Form2_ToolBarHeight:           dw 8
     ds 136+14
.Form2_Menu:                    
        dw  0
;****
;**** Data Control Record (ControlWindow) ****
;****
.Form2_ControlWindow:           
.Form2_ControlWindowCount:      db 5
.Form2_ControlWindowOwnerID:    db 0
.Form2_ControlWindowDataAddr:   dw Form2_ControlWindowData
.Form2_ControlWindowCalcAddr:   dw 0; Form2_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form2_ControlWindowFocus:      db 0
     db 0
;****
.Form2_ControlWindowData:       
;**** OBject Window Background Data Record ****
dw 0,255*256+0,          2,  0,0,1000,1000,0
;**** Object (Button3) Data Record ****
.Button3_ID:                    dw 1
.Button3_Type:                  db 16   ;* Paint
.Button3_ExtDataBank:           db 255
.Button3_ExtDataAddr:           dw Button3_ExtData
.Button3_Left:                  dw 20
.Button3_Top:                   dw 5
.Button3_Width:                 dw 50
.Button3_Height:                dw 11
.Button3_Code:                  dw 0
;**** Object (Button4) Data Record ****
.Button4_ID:                    dw 2
.Button4_Type:                  db 16   ;* Paint
.Button4_ExtDataBank:           db 255
.Button4_ExtDataAddr:           dw Button4_ExtData
.Button4_Left:                  dw 117
.Button4_Top:                   dw 36
.Button4_Width:                 dw 50
.Button4_Height:                dw 11
.Button4_Code:                  dw 0
;**** Object (Button5) Data Record ****
.Button5_ID:                    dw 3
.Button5_Type:                  db 16   ;* Paint
.Button5_ExtDataBank:           db 255
.Button5_ExtDataAddr:           dw Button5_ExtData
.Button5_Left:                  dw 21
.Button5_Top:                   dw 47
.Button5_Width:                 dw 50
.Button5_Height:                dw 11
.Button5_Code:                  dw 0
;**** Object (ImageBox2) Data Record ****
.ImageBox2_ID:                  dw 4
.ImageBox2_Type:                db 8   ;* VSpinner
.ImageBox2_ExtDataBank:         db 255
.ImageBox2_GraphicAddr:         dw ImageBox2_GraphicData
.ImageBox2_Left:                dw 20
.ImageBox2_Top:                 dw 63
.ImageBox2_Width:               dw 128
.ImageBox2_Height:              dw 53
.ImageBox2_Code:                dw 0
;**** Object (Button3) Extra Data Record **** (see in Data Section)
;**** Object (Button4) Extra Data Record **** (see in Data Section)
;**** Object (Button5) Extra Data Record **** (see in Data Section)
.GroupStatus0:  db  16
.GroupCoord0:   db  -1,-1,-1,-1
;*******************************
;***** Symbos Code Library *****
;*******************************

Library SyStr_LenMax
;*********************************************
;**** Get the Maximum Length of a System String
;**** IN - HL = Start of Text
		dec		hl
		ld		a,(hl)
		inc		hl
		ret
;*********************************************
EndLib

Library SyStr_Len
;*********************************************
;**** Get the Length of a System String
;**** IN - HL = Address Start of Text
;**** OUT - HL = Address End of Text
;****       B = Length
		ld		b,0
.SyStr_Len2
		ld		a,(hl)
		And		a
		ret		z
		inc		hl
		inc		b
		jr		SyStr_Len2	
;*********************************************
EndLib

Library SyStr_Copy
;*********************************************
;**** Copy a String to Another String (without exceeeding Destingation string size)
;**** IN - DE = Addr of Source String
;****      HL = Addr of Destination String
		dec		hl
		ld		a,(hl)
		And		a
		jr		z,SyStr_Copy_2
		ld		b,a
		inc		hl
.SyStr_Copy_1
		ld		a,(de)
		ld		(hl),a
		inc		hl
		inc		de
		And		a
		jr		z,SyStr_Copy_2
		djnz	SyStr_Copy
.SyStr_Copy_2
		ret
;*********************************************
EndLib

Library SyMath_RND16
;*********************************************
;**** Random number generator 16 bit
;**** IN - Nowt
;**** OUT - HL = Random
;**** Corrupts A,DE,F 
		ld		de,(SyMath_RndSeed)		; Seed is usually 0
		ld		a,d
		ld		h,e
		ld		l,253
		Or		a
		sbc		hl,de
		sbc		a,0
		sbc		hl,de
		ld		d,0
		sbc		a,d
		ld		e,a
		sbc		hl,de
		jr		nc,SyMath_Rand
		inc		hl
.SyMath_Rand
		ld		(SyMath_RndSeed),hl
		ret
EndL		
;*******************************************
Library SyMath_RndSeed
;*******************************************
;**** Just the Seeding Word 
		dw	0	
;*******************************************
EndL

;Library SyVar_Num2Str
;*******************************************
;### CLCNUM -> Converts 16Bit-number into an ASCII-string (terminated by 0)
;### Input      IX=Value, E=maximum number of digits
;### Output     IY=points to last char of the string (before 0)
;### Changed    AF,BC,DE,HL,IX,IY
;.SyVar_clcnumt
;		dw 1,10,100,1000,10000
;.SyVar_Num2Str
;		ld d,0
;       ld b,e
;      dec e
;        push ix
;        pop hl
;        ld ix,clcnumt
;        add ix,de
;        add ix,de               ;IX=erster Teiler
;        dec b
;        jr z,clcnum4
;        ld c,0
;clcnum1 ld e,(ix)
;        ld d,(ix+1)
;        dec ix
;        dec ix
;        ld a,"0"
;        Or a
;clcnum2 sbc hl,de
;        jr c,clcnum5
;        inc c
;        inc a
;        jr clcnum2
;clcnum5 add hl,de
;        inc c
;        dec c
;        jr z,clcnum3
;        ld (iy+0),a
;        inc iy
;clcnum3 djnz clcnum1
;clcnum4 ld a,"0"
;        add l
;        ld (iy+0),a
;        ld (iy+1),0
;        ret
;EndLib

Library SyMath_Mult32
;*******************************************
; In: IY/IX: eerste getal (low/high)
;     HL/BC: tweede getal (low/high)
; Uit: HL/DE: resultaat (low/high)
				exx
                ld      hl,0
                ld      de,0
                exx
SyMath_Multi32_lp:
				srl     b
                rr      c
                rr      h
                rr      l
                jp      nc,SyMath_multi32_2
                exx
                push    iy
                pop     bc
                add     hl,bc
                ex      de,hl
                push    ix
                pop     bc
                adc     hl,bc
                ex      de,hl
                exx
SyMath_multi32_2:
				ld      a,h
                Or      l
                jp      nz,SyMath_Multi32_3
                ld      a,b
                Or      c
                jp      z,SyMath_multi32_5
SyMath_multi32_3:
				add     iy,iy
                jp      nc,SyMath_multi32_4
                add     ix,ix
                inc     ix
                jp      SyMath_multi32_lp
SyMath_multi32_4:
				add     ix,ix
                jp      SyMath_multi32_lp
SyMath_multi32_5:
				exx
                ret
;**************************************
EndLib

Library SyMath_Div32
;**************************************
; In: HL/DE: teller (low/high)
;     IX/IY: noemer (low/high)
; Uit: HL/DE: resultaat (low/high)
		        push    hl
                push    de
                push    ix
                push    iy
                pop     de
                exx
                pop     de
                pop     bc
                pop     iy
                ld      hl,0
                exx
                ld      hl,0
                ld      b,32
.SyMath_divide32_1
				exx
                add     iy,iy
                rl      c
                rl      b
                adc     hl,hl
                exx
                adc     hl,hl
                exx
                sbc     hl,de
                exx
                sbc     hl,de
                inc     iy
                jp      nc,SyMath_divide32_2
                dec     iy
                exx
                add     hl,de
                exx
                adc     hl,de
.SyMath_divide32_2
				djnz    SyMath_divide32_1
                exx
                push    bc
                exx
                pop     de
                push    iy
                pop     hl
                ret
;*************************************
EndLib

Library SyMath_Add32
;*************************************
; In: HL/DE: eerste getal (low/high)
;     IX/IY: tweede getal (low/high)
; Uit: HL/DE: resultaat (low/high)
				push    ix
                pop     bc
                add     hl,bc
                ex      de,hl
                push    iy
                pop     bc
                adc     hl,bc
                ex      de,hl
                ret
;************************************
EndLib

Library SyMath_Sub32
;************************************
; In: HL/DE: eerste getal (low/high)
;     IX/IY: tweede getal (low/high)
; Uit: HL/DE: resultaat (low/high)
				push    ix
                pop     bc
                Xor     a
                sbc     hl,bc
                ex      de,hl
                push    iy
                pop     bc
                sbc     hl,bc
                ex      de,hl
                ret
;************************************
EndLib
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M S T U D I O   S Y S T E M   L I B R A R Y               @
;@                        - SYMBOS KERNEL FUNCTIONS -                         @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;Author: Prodatron / Symbiosis
;Date:   28.10.2005

;The kernel is the heart of SymbOS and controls the core resources of the
;system.
;This library supports you in using the kernel functions regarding processes
;and timers.
;The existance of "AppPrzN" (a byte, where the ID of the applications process
;is stored) and "AppMsgB" (the message buffer, 14 bytes, which are placed in
;the transfer ram area) is required.


Library SyKernel_MTADDP
;******************************************************************************
;*** Name           Multitasking_Add_Process_Command
;*** Input          HL = Stack address (see notes below)
;***                A  = Ram bank (0-8)
;***                E  = Priority (1=highest, 7=lowest)
;*** Output         A  = Process ID
;***                CF = Success status
;***                     0 = OK
;***                     1 = the process couldn't been added, as the maximum
;***                         number of processes (32) has been reached
;*** Destroyed      BC,DE,HL,IX,IY
;*** Description    Adds a new process with a given priority and starts it
;***                immediately.
;***                Application processes usually will be started with priority 4.
;***                Note, that the desktop manager process runs with priority 1,
;***                the system manager process with 2. If you start a process,
;***                which should do some long and intensive calculation, you should
;***                choose a priority greater than 4, so that other applications
;***                will not be disturbed.
;***                The stack must always be placed between #C000 and #FFFF
;***                (transfer ram area). It must contain the start address of the
;***                process routine at offset 12 and may contain the initial values
;***                of the registers. You can choose the size of the stack buffer
;***                by yourself, just be sure, that it is large enough.
;*** Example(stack)                ds 128              ;Stack buffer
;***                stack_pointer: dw 0                ;initial value for IY
;***                               dw 0                ;initial value for IX
;***                               dw 0                ;initial value for HL
;***                               dw 0                ;initial value for DE
;***                               dw 0                ;initial value for BC
;***                               dw 0                ;initial value for AF
;***                               dw process_start    ;process start address
;******************************************************************************
        ld c,MSC_KRL_MTADDP
        call SyKernel_Message
        xor a
        cp l
        ld a,h
        ret
EndLib

Library SyKernel_MTDELP
;******************************************************************************
;*** Name           Multitasking_Delete_Process_Command
;*** Input          L  = Process ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Stops an existing process and deletes it.
;******************************************************************************
        ld c,MSC_KRL_MTDELP
        jp SyKernel_Message
EndLib

Library SyKernel_MTADDT
;******************************************************************************
;*** Name           Multitasking_Add_Timer_Command
;*** Input          HL = Stack address (see notes below)
;***                A  = Ram bank (0-8)
;*** Output         A  = Timer ID
;***                CF = Success status
;***                     0 = OK
;***                     1 = the timer couldn't been added, as the maximum
;***                         number of timers (32) has been reached
;*** Destroyed      BC,DE,HL,IX,IY
;*** Description    Adds a new timer and starts it immediately. Timers will be
;***                called 50times per second. Please see MSC_KRL_MTADDP for
;***                information about the stack.
;******************************************************************************
        ld c,MSC_KRL_MTADDT
        call SyKernel_Message
        xor a
        cp l
        ld a,h
        ret
EndLib

Library SyKernel_MTDELT
;******************************************************************************
;*** Name           Multitasking_Delete_Timer_Command
;*** Input          L  = Timer ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Stops an existing timer and deletes it.
;******************************************************************************
        ld c,MSC_KRL_MTDELT
        jp SyKernel_Message
EndLib

Library SyKernel_MTSLPP
;******************************************************************************
;*** Name           Multitasking_Sleep_Process_Command
;*** Input          L  = Process ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Puts an existing process into the sleep mode. It is stopped and
;***                does not run anymore, until it receives a message, or until it
;***                will be wacked up again (see MSC_KRL_MTWAKP).
;***                Usually this command is not needed, as a process can put itself
;***                into the sleep mode with the MSGSLP restart (see above).
;******************************************************************************
        ld c,MSC_KRL_MTSLPP
        jp SyKernel_Message
EndLib

Library SyKernel_MTWAKP
;******************************************************************************
;*** Name           Multitasking_WakeUp_Process_Command
;*** Input          L  = Process ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Wakes up a process, which was sleeping before. A process will
;***                be wacked up, too, when another process is sending a message to
;***                it.
;******************************************************************************
        ld c,MSC_KRL_MTWAKP
        jp SyKernel_Message
EndLib


;### SUB ROUTINES #############################################################

Library SyKernel_Message
;******************************************************************************
;*** Input          C      = Command
;***                HL,A,E = Additional parameters
;*** Output         HL     = returned parameters
;*** Destroyed      AF,BC,DE,IX,IY
;*** Description    Sends a message to the kernel, waits for the answer and
;***                returns the result
;******************************************************************************
        ld iy,AppMsgB
        ld (iy+0),c
        ld (iy+1),l
        ld (iy+2),h
        ld (iy+3),a
        ld (iy+4),e
        ld a,c
        add 128
        ld (SyKMsgN),a
        db #dd:ld h,1       ;1 is the number of the kernel process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #10
SyKMsg1 db #dd:ld h,1       ;1 is the number of the kernel process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #08             ;wait for a kernel message
        db #dd:dec l
        jr nz,SyKMsg1
        ld a,(SyKMsgN)
        cp (iy+0)
        jr nz,SyKMsg1
        ld l,(iy+1)
        ld h,(iy+2)
        ret
SyKMsgN db 0
EndLib
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M S T U D I O   S Y S T E M   L I B R A R Y               @
;@                     - SYMBOS FILE MANAGER FUNCTIONS -                      @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;Author: Prodatron / Symbiosis
;Date:   27.10.2005

;This library supports you in using the file manager functions.
;Instead of including the following routines in your application code you may
;use the "SySystem_CallFunction" routine directly, so that you would save some
;overhead. In this case you can see this library just as an example, how to
;access the file manager.
;The existance of "AppPrzN" (a byte, where the ID of the applications process
;is stored) and "AppMsgB" (the message buffer, 14 bytes, which are placed in
;the transfer ram area) is required.


Library SyFile_FILNEW
;******************************************************************************
;*** Name           File_New
;*** Input          IXH  = File path and name ram bank (0-8)
;***                HL   = File path and name address
;***                A    = Attributes
;***                       Bit0 = 1 -> Read only
;***                       Bit1 = 1 -> Hidden
;***                       Bit2 = 1 -> System
;***                       Bit5 = 1 -> Archive
;*** Output         A    = Filehandler ID
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      F,BC,DE,HL,IX,IY
;*** Description    Creates a new file and opens it for read/write access. If the
;***                file was already existing, it will be emptied first. For
;***                additional information see 018 (FILOPN).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILNEW
        ret
EndLib

Library SyFile_FILOPN
;******************************************************************************
;*** Name           File_Open
;*** Input          IXH  = File path and name ram bank (0-8)
;***                HL   = File path and name address
;*** Output         A    = Filehandler ID
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      F,BC,DE,HL,IX,IY
;*** Description    Opens an existing file for read/write access. This means, that
;***                you can read and write in the file like you want. You can open
;***                up to 8 different files at the same time.
;***                For more information about the file path see the introduction
;***                of the DIRECTORY MANAGEMENT FUNCTIONS.
;***                The media will be reloaded first, if the device is set to
;***                "removeable media" and there is no other open file on the same
;***                device.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN
        ret
EndLib

Library SyFile_FILCLO
;******************************************************************************
;*** Name           File_Close
;*** Input          A    = Filehandler ID
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Closes an opened file. If there is unwritten data in the sector
;***                cache, it will be written to disc at once.
;***                This command closes a file in any case, even if an error
;***                occured.
;***                If an error occured during file reading/writing you must close
;***                the file, too, to have the filehandler free again!
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        ret
EndLib

Library SyFile_FILINP
;******************************************************************************
;*** Name           File_Input
;*** Input          A    = Filehandler ID
;***                HL   = Destination address
;***                E    = Destination ram bank (0-8)
;***                BC   = Number of bytes
;*** Output         BC   = Number of read bytes
;***                ZF   = 1 -> All requested bytes have been read
;***                       0 -> The end of the file has been reached, and less
;***                            bytes than requested have been read (check BC)
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,DE,HL,IX,IY
;*** Description    Reads a specified amount of bytes out of an opened file. After
;***                this operation the file pointer will be moved behind the last
;***                read byte. This means, that it is possible to read several
;***                blocks with different sizes out of an opened file. It doesn't
;***                matter, if you already did write operations, too.
;***                If you try to read more bytes than available, the zero flag
;***                will be reset. In any case BC contains the amount of read
;***                bytes.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        ret
EndLib

Library SyFile_FILOUT
;******************************************************************************
;*** Name           File_Output
;*** Input          A    = Filehandler ID
;***                HL   = Source address
;***                E    = Source ram bank (0-8)
;***                BC   = Number of bytes
;*** Output         BC   = Number of written bytes
;***                A    = 0 -> All bytes have been written
;***                       1 -> The device is full, and less bytes have been
;***                            written (check BC)
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,DE,HL,IX,IY
;*** Description    Writes a specified amount of bytes into an opened file. After
;***                this operation the file pointer will be moved behind the last
;***                written byte. If the file pointer has been somewhere in the
;***                middle of the file before this operation, the data at this
;***                place will be overwritten. If you have been at the end of the
;***                file, its length will be extended.
;***                You can write several blocks with different sizes, and it
;***                doesn't matter if you already read from the file before.
;***                It's possible, that not all bytes have been written, if the
;***                device is full. Register A will be 1 in this case. In any case
;***                BC contains the amount of written bytes.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOUT
        ret
EndLib

Library SyFile_FILPOI
;******************************************************************************
;*** Name           File_Pointer
;*** Input          A    = Filehandler ID
;***                IY,IX= Difference
;***                C    = Reference point
;***                       0 = File begin
;***                       1 = Actual pointer position
;***                       2 = File end
;*** Output         IY,IX= new absolute pointer position
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL
;*** Description    Moves the file pointer to another position. The difference is
;***                specified with IY and IX, IY is the high word, IX the low word
;***                (difference = 65536 * IY + IX).
;***                You can also use this function to find out the length of an
;***                opened file. Just set IY,IX to 0 and choose 2 as the reference
;***                point type. The pointer will be placed behind the last byte of
;***                the file, so you will get its length in IY,IX.
;*** Examples       IY = 0,     IX = 1,   C = 1 -> Increases the position by 1
;***                IY = 65535, IX = -10, C = 2 -> Sets the pointer before the last
;***                                               10 bytes of the file
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILPOI
        ret
EndLib

Library SyFile_FILF2T
;******************************************************************************
;*** Name           File_Decode_Timestamp
;*** Input          BC   = Time code
;***                       bit  0- 4 = second/2
;***                       bit  5-10 = minute
;***                       bit 11-15 = hour
;***                DE   = Date code
;***                       bit  0- 4 = day (starting from 1)
;***                       bit  5- 8 = month (starting from 1)
;***                       bit  9-15 = year-1980
;*** Output         A    = second
;***                B    = minute
;***                C    = hour
;***                D    = day (starting from 1)
;***                E    = month (starting from 1)
;***                HL   = year
;*** Destroyed      F
;*** Description    Decodes the file timestamp, which is used for the file system.
;***                You can use this function after reading the timestamp of a
;***                file with 035 (DIRPRR) or 038 (DIRINP).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILF2T
        ret
EndLib

Library SyFile_FILT2F
;******************************************************************************
;*** Name           File_Encode_Timestamp
;*** Input          A    = second
;***                B    = minute
;***                C    = hour
;***                D    = day (starting from 1)
;***                E    = month (starting from 1)
;***                HL   = year
;*** Output         BC   = Time code (see FILF2T)
;***                DE   = Date code (see FILF2T)
;*** Destroyed      AF,HL,IX,IY
;*** Description    Encodes the file timestamp, which is used for the file system.
;***                You can use this function before changing the timestamp of a
;***                file with 034 (DIRPRS).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILT2F
        ret
EndLib

Library SyFile_FILLIN
;******************************************************************************
;*** Name           File_LineInput
;*** Input          A    = Filehandler ID
;***                HL   = Destination buffer address (size must be 255 bytes)
;***                E    = Destination buffer ram bank (0-8)
;*** Output         BC   = Number of read bytes (without terminator)
;***                ZF   = 0 -> 1 or more bytes have been loaded
;***                       1 -> EOF reached, nothing has been loaded
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,DE,HL,IX,IY
;*** Description    Reads one text line out of an opened file. A text line is
;***                terminated by a single 13, a single 10, a combination of 13+10,
;***                a combination of 10+13 or by a single 26 ("end of file" code).
;***                The line terminator will not be copied to the destination line
;***                buffer, but a 0 will be added behind the last char of the line.
;***                This function allows you to read a text file line by line at a
;***                very high speed, because you don't need to read single chars
;***                and check for line feeds by yourself.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILLIN
        ret
EndLib


Library SyFile_DIRDEV
;******************************************************************************
;*** Name           Directory_Device
;*** Input          A    = Driveletter ("A"-"Z")
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Selects the actual drive.
;***                As your application is running in a multitasking environment,
;***                unfortunately this command does not make many sense, as other
;***                applications could select an other drive again.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRDEV
        ret
EndLib

Library SyFile_DIRPTH
;******************************************************************************
;*** Name           Directory_Path
;*** Input          IXH  = File path ram bank (0-8)
;***                HL   = File path address
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Selects the actual path for the actual or a different drive.
;***                As your application is running in a multitasking environment,
;***                unfortunately this command does not make many sense, as other
;***                applications could select an other path again.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRPTH
        ret
EndLib

Library SyFile_DIRPRS
;******************************************************************************
;*** Name           Directory_Property_Set
;*** Input          IXH  = File path and name ram bank (0-8)
;***                HL   = File path and name address
;***                A    = Property type
;***                       0 = Attribute          -> C  = attribute
;***                                                      Bit0 = 1 -> Read only
;***                                                      Bit1 = 1 -> Hidden
;***                                                      Bit2 = 1 -> System
;***                                                      Bit5 = 1 -> Archive
;***                       1 = Timestamp modified -> BC = time code, DE = date code
;***                       2 = Timestamp created  -> BC = time code, DE = date code
;***                BC,DE= see above
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Changes a property of a file or a directory. You can set the
;***                attribute, the "created" time and the "modified" time.
;***                For more information about the time and date code see 023
;***                (FILF2T).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRPRS
        ret
EndLib

Library SyFile_DIRPRR
;******************************************************************************
;*** Name           Directory_Property_Get
;*** Input          IXH  = File path and name ram bank (0-8)
;***                HL   = File path and name address
;***                A    = Property type
;***                       0 = Attribute
;***                       1 = Timestamp modified
;***                       2 = Timestamp created
;*** Output         C    = Attributes (if requested)
;***                       Bit0 = 1 -> Read only
;***                       Bit1 = 1 -> Hidden
;***                       Bit2 = 1 -> System
;***                       Bit3 = 1 -> Volume ID
;***                       Bit4 = 1 -> Directory
;***                       Bit5 = 1 -> Archive
;***                BC,DE= Time and date code (if requested)
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,HL,IX,IY
;*** Description    Reads a property of a file or a directory.
;***                For more information about the time and date code see 023
;***                (FILF2T).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRPRR
        ret
EndLib

Library SyFile_DIRREN
;******************************************************************************
;*** Name           Directory_Rename
;*** Input          IXH  = Ram bank (0-8) of old and new file name
;***                HL   = Address of file path and old file name
;***                DE   = Address of new file name
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Renames a file or a directory. The new file name must not
;***                include a path. The function will fail, if a file or directory
;***                with the new name already exists.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRREN
        ret
EndLib

Library SyFile_DIRNEW
;******************************************************************************
;*** Name           Directory_New
;*** Input          IXH  = Directory path and name ram bank (0-8)
;***                HL   = Directory path and name address
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Creates a new directory. The function will fail, if a file or
;***                directory with the same name already exists.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRNEW
        ret
EndLib

Library SyFile_DIRINP
;******************************************************************************
;*** Name           Directory_Input
;*** Input          IXH  = Directory path ram bank (0-8)
;***                HL   = Directory path address (may include a search mask)
;***                IXL  = forbidden attributes
;***                       Bit0 = 1 -> don't show read only files
;***                       Bit1 = 1 -> don't show hidden files
;***                       Bit2 = 1 -> don't show system files
;***                       Bit3 = 1 -> don't show volume ID entries
;***                       Bit4 = 1 -> don't show directories
;***                       Bit5 = 1 -> don't show archive files
;***                A    = Destination buffer ram bank (0-8)
;***                DE   = Destination buffer address
;***                BC   = Destination buffer length
;***                IY   = Number of entries, which should be skipped
;*** Output         HL   = Number of read entries
;***                BC   = Remaining unused space in the destination buffer
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,DE,IX,IY
;*** Data structure 00  4B  File length (32bit double word)
;***                04  1W  Date code, see 023 (FILF2T)
;***                06  1W  Time code, see 023 (FILF2T)
;***                08  1B  Attributes, see 035 (DIRPRR)
;***                09  ?B  File or sub directory name
;***                ??  1B  0 terminator
;*** Description    Reads the content of a directory. You can specify a name filter
;***                filter by adding a file mask to the path (* and ? are allowed)
;***                and an attribute filter. We recommend always to set Bit3
;***                (volume ID) of the attribute filter byte.
;***                The system skips the specified amount of entries first and
;***                then loads as many entries as exist or as there is place in the
;***                destination buffer. Please note, that the entries will not be
;***                sorted. Depending on its name every entry in the destination
;***                buffer can have a different length and is terminated with 0
;***                behind the file name. Filenames don't contain spaces.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRINP
        ret
EndLib

Library SyFile_DIRDEL
;******************************************************************************
;*** Name           Directory_DeleteFile
;*** Input          IXH  = File path and name/mask ram bank (0-8)
;***                HL   = File path and name/mask address
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Deletes one or more files. You can delete multiple files by
;***                using a file mask (* and ? are allowed).
;***                This function can't be used for deleting directories.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRDEL
        ret
EndLib

Library SyFile_DEVDIR
;******************************************************************************
;*** Name           Directory_Input_Extended
;*** Input          A    = [bit0-3] Destination buffer ram bank (0-8)
;***                       [bit4-7] Directory path ram bank (0-8)
;***                HL   = Directory path address (may include a search mask)
;***                DE   = Destination buffer address. This must first contain two
;***                       words with additional information at the beginning:
;***                       00  1W  Address of list control table
;***                       02  1W  Maximum number of entries
;***                       This function will overwrite this information and fill
;***                       the buffer with the directory data.
;***                BC   = Maximum size of destination buffer
;***                IXL  = forbidden attributes
;***                       Bit0 = 1 -> don't show read only files
;***                       Bit1 = 1 -> don't show hidden files
;***                       Bit2 = 1 -> don't show system files
;***                       Bit3 = 1 -> don't show volume ID entries
;***                       Bit4 = 1 -> don't show directories
;***                       Bit5 = 1 -> don't show archive files
;***                IY   = Number of entries, which should be skipped
;***                IXH  = Additional columns
;***                       Bit0 = 1 -> File size
;***                       Bit1 = 1 -> Date and time (last modified)
;***                       Bit2 = 1 -> Attributes
;*** Output         HL   = Number of read entries
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,IX,IY
;*** Description    This is a very powerful extension of the directory input
;***                (DIRINP) function. It reads the content of a directory and
;***                converts it into ready to use list control data. So if your
;***                application wants to display the content of a directory inside
;***                a list control, it can use this function and doesn't need to do
;***                any conversion jobs by itself. Also the list control itself can
;***                do the sorting of the directory.
;***                First you have to reserve two memory areas in the same ram
;***                bank. One area needs to be reserved inside the data ram area.
;***                It will contain the texts (file names, dates etc.) and numbers
;***                (file sizes) for the list control. You can choose any size, but
;***                we recommend at least 4000 Bytes. BC must contain its size,
;***                when you call the function. DE contains the address, and the
;***                low nibble of A the ram bank number.
;***                The second area needs to be reserved inside the transfer ram
;***                area of the same bank. It contains the data structure of the
;***                list control. It size is calculated like this:
;***                Size = Maximum_number_of_entries * (4 + Additional_columns * 2)
;***                So when you have two additional columns (like date and
;***                attributes) and want to load up to 100 entries, you need to
;***                reserve 800 bytes.
;***                As there are no more Z80-registers available, the address of
;***                this memory area and the maximum number of entries must be
;***                written to the beginning of the other memory area.
;***                For additional information about reading directories see 038
;***                (DIRINP).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DEVDIR
        ret
EndLib


;### SUB ROUTINES #############################################################

Library SySystem_CallFunction
;******************************************************************************
;*** Name           System_CallFunction
;*** Input          ((SP+0)) = System manager command
;***                ((SP+1)) = Function ID
;***                AF,BC,DE,HL,IX,IY = Input for the function
;*** Output         AF,BC,DE,HL,IX,IY = Output from the function
;*** Destroyed      -
;*** Description    Calls a function via the system manager. This function is
;***                needed to have access to the file manager.
;******************************************************************************
        ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
SyCallN db 0
EndLib
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M S T U D I O   S Y S T E M   L I B R A R Y               @
;@                    - SYMBOS SYSTEM MANAGER FUNCTIONS -                     @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;Author: Prodatron / Symbiosis
;Date:   28.10.2005

;The system manager is responsible for starting and stopping applications and
;it also provides several dialogue services.
;This library supports you in using the system manager functions.
;The existance of "AppPrzN" (a byte, where the ID of the applications process
;is stored) and "AppMsgB" (the message buffer, 14 bytes, which are placed in
;the transfer ram area) is required.


Library SySystem_PRGRUN
;******************************************************************************
;*** Name           Program_Run_Command
;*** Input          HL = File path and name address
;***                A  = [Bit0-3] File path and name ram bank (0-8)
;***                     [Bit7  ] Flag, if system error message should be
;***                              suppressed
;*** Output         A  = Success status
;***                     0 = OK
;***                     1 = File does not exist
;***                     2 = File is not an executable and its type is not
;***                         associated with an application
;***                     3 = Error while loading (see P8 for error code)
;***                     4 = Memory full
;***                - If success status is 0:
;***                L  = Application ID
;***                H  = Process ID (the applications main process)
;***                - If success status is 3:
;***                L  = File manager error code
;*** Destroyed      F,BC,DE,IX,IY
;*** Description    Loads and starts an application or opens a document with a
;***                known type by loading the associated application first.
;***                If Bit7 of A is not set, the system will open a message box,
;***                if an error occurs during the loading process.
;***                If the operation was successful, you will find the
;***                application ID and the process ID in L and H. If it failed
;***                because of loading problems L contains the file manager
;***                error code.
;******************************************************************************
        ld c,MSC_SYS_PRGRUN
        call SySystem_SendMessage
SySPRn1 call SySystem_WaitMessage
        cp MSR_SYS_PRGRUN
        jr nz,SySPRn1
        ld a,(iy+1)
        ld l,(iy+8)
        ld h,(iy+9)
        ret
EndLib

Library SySystem_PRGEND
;******************************************************************************
;*** Name           Program_End_Command
;*** Input          L  = Application ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Stops an application and releases all its used system
;***                resources. This command first stops all processes of the
;***                application. After this all open windows will be closed and the
;***                reserved memory will be released.
;***                Please note, that this command can't release memory, stop
;***                processes or close windows, which are not registered for the
;***                application. Such resources first have to be released by the
;***                application itself.
;******************************************************************************
        ld c,MSC_SYS_PRGEND
        jp SySystem_SendMessage
EndLib

Library SySystem_SYSWRN
;******************************************************************************
;*** Name           Dialogue_Infobox_Command
;*** Input          HL = Content data address (#C000-#FFFF)
;***                A  = Content data ram bank (0-8)
;***                E  = [Bit0-6] Number of buttons (MUST BY ALWAYS 1)
;***                     [Bit7  ] Box type
;***                              0 = warning (default warning symbol)
;***                              1 = info (own symbol will be used)
;*** Content data   00  1W  Address of text line 1
;***                02  1W  4 * [text line 1 pen] + 2
;***                04  1W  Address of text line 2
;***                06  1W  4 * [text line 2 pen] + 2
;***                08  1W  Address of text line 3
;***                10  1W  4 * [text line 3 pen] + 2
;***                - if E[bit7] is 1:
;***                12  1W  Address of symbol (24x24 pixel SymbOS graphic format)
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Opens an info or warning box and displays three line of text
;***                and one "OK" button. If Bit7 of E is set to 1 you can specify
;***                an own symbol, which will be showed left to the text. If this
;***                bit is not set, a "!"-warning symbol will be displayed.
;***                Currently multiple choice alert boxes are not supported, which
;***                means, that the number of buttons always have to be set to 1.
;***                Please note, that the content data must always be placed in the
;***                transfer ram area (#C000-#FFFF). The texts itself and the
;***                optional graphic must always be placed inside a 16K (data ram
;***                area).
;***                As the text line pen, you should choose 1, so 6 would be the
;***                correct value.
;***                For more information about the mentioned memory types (data,
;***                transfer) see the "applications" chapter.
;***                For more information about the SymbOS graphic format see the
;***                "desktop manager data records" chapter.
;******************************************************************************
        ld c,MSC_SYS_SYSWRN
        jp SySystem_SendMessage
EndLib

Library SySystem_SELOPN
;******************************************************************************
;*** Name           Dialogue_FileSelector_Command
;*** Input          HL = File mask, path and name address (#C000-#FFFF)
;***                     00  3B  File extension filter (e.g. "*  ")
;***                     03  1B  0
;***                     04 256B path and filename
;***                A  = File mask, path and name ram bank (0-8)
;***                C  = Attribute filter
;***                     Bit0 = 1 -> don't show read only files
;***                     Bit1 = 1 -> don't show hidden files
;***                     Bit2 = 1 -> don't show system files
;***                     Bit3 = 1 -> don't show volume ID entries
;***                     Bit4 = 1 -> don't show directories
;***                     Bit5 = 1 -> don't show archive files
;***                IX = Maximum number of directory entries
;***                IY = Maximum size of directory data buffer
;***                DE = Data record of the caller window; the file selector
;***                     window will be a super window of it, during its open)
;*** Output         A  = Success status
;***                     0 -> The user choosed a file and closed the dialogue
;***                          with "OK". The complete file path and name can be
;***                          found in the filepath buffer of the application.
;***                     1 -> The user aborted the file selection. The content
;***                          of the applications filepath buffer is unchanged.
;***                     2 -> The file selection dialogue is currently used by
;***                          another application. It can only be opened once
;***                          at the same time. The user should close the
;***                          dialogue first before it can be opened again by
;***                          the application.
;***                     3 -> Memory full. There was not enough memory
;***                          available for the directory buffer and/or the
;***                          list data structure.
;***                     4 -> No window available. The desktop manager couldn't
;***                          open a new window for the dialogue, as the
;***                          maximum number of windows (32) has already been
;***                          reached.
;*** Destroyed      F,BC,DE,HL,IX,IY
;*** Description    Opens the file selection dialogue. In this dialogue the user
;***                can move through the directory structure, change the drive and
;***                search and select a file.
;***                If you specify a path, the dialogue will start directly in the
;***                directory. If you append a filename, too, it will be used as
;***                the preselected file.
;***                You can filter the entries of the directory by attributes and
;***                filename extension. We recommend always to set Bit3 of the
;***                attribute filter byte.
;***                The File mask/path/name string (260 bytes) must always be
;***                placed in the transfer ram area (#C000-#FFFF). For more
;***                information about this memory types see the "applications"
;***                chapter.
;***                Please note, that the system will reserve memory to store the
;***                listed directory entries and the data structure of the list.
;***                With IX and IY you can choose, how much memory should be used.
;***                We recommend to set the number of entries between 100 and 200
;***                (Amsdos supports a maximum amount of 64 entries) and to set the
;***                data buffer between 5000 and 10000.
;******************************************************************************
        ld (SySSOpW),de
        push iy
        ld iy,AppMsgB
        ld (iy+6),a
        ld (iy+7),c
        ld (iy+8),l
        ld (iy+9),h
        db #dd:ld a,l
        ld (iy+10),a
        db #dd:ld a,h
        ld (iy+11),a
        pop de
        ld (iy+12),e
        ld (iy+13),d
        ld c,MSC_SYS_SELOPN
        call SySystem_SendMessage
SySSOp1 call SySystem_WaitMessage
        cp MSR_SYS_SELOPN
        jr nz,SySSOp1
        ld a,(iy+1)
        cp -1
        ret nz
        ld ix,(SySSOpW)
        ld a,(iy+2)
        ld (ix+51),a
        jr SySSOp1
SySSOpW dw 0
EndLib


;### SUB ROUTINES #############################################################

Library SySystem_SendMessage
;******************************************************************************
;*** Input          C       = Command
;***                HL,A,DE = additional Parameters
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sends a message to the system manager
;******************************************************************************
        ld iy,AppMsgB
        ld (iy+0),c
        ld (iy+1),l
        ld (iy+2),h
        ld (iy+3),a
        ld (iy+4),e
        ld (iy+5),d
        db #dd:ld h,3       ;3 is the number of the system manager process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #10
        ret
EndLib

Library SySystem_WaitMessage
;******************************************************************************
;*** Input          -
;*** Output         IY = message buffer
;***                A  = first byte in the Message buffer (IY+0)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sends a message to the desktop manager, which includes the
;***                window ID and additional parameters
;******************************************************************************
        ld iy,AppMsgB
SySWMs1 db #dd:ld h,3       ;3 is the number of the system manager process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #08             ;wait for a system manager message
        db #dd:dec l
        jr nz,SySWMs1
        ld a,(iy+0)
        ret
EndLib
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M S T U D I O   S Y S T E M   L I B R A R Y               @
;@                    - SYMBOS DESKTOP MANAGER FUNCTIONS -                    @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;Author: Prodatron / Symbiosis
;Date:   27.10.2005

;The desktop manager is responsible for all actions, which are taking place on
;the video screen. Especially the handling of the application windows is done
;by the desktop manager.
;This library supports you in using the desktop manager functions.
;The existance of "AppPrzN" (a byte, where the ID of the applications process
;is stored) and "AppMsgB" (the message buffer, 14 bytes, which are placed in
;the transfer ram area) is required.


Library SyDesktop_WINOPN
;******************************************************************************
;*** Name           Window_Open_Command
;*** Input          A  = Window data record ram bank (0-8)
;***                DE = Window data record address (#C000-#FFFF)
;*** Output         A  = Window ID (only, if CF=0)
;***                CF = Success status
;***                     0 = OK
;***                     1 = window couldn't be opened, as the maximum number
;***                         of windows (32) has been reached
;*** Destroyed      BC,DE,HL,IX,IY
;*** Description    Opens a new window. Its data record must be placed in the
;***                transfer ram area (between #c000 and #ffff).
;***                For more information about the window data record see the
;***                chapter "desktop manager data records".
;***                For more information about the transfer ram memory types see
;***                the "applications" chapter.
;******************************************************************************
        ld c,MSC_DSK_WINOPN
        call SyDesktop_SendMessage
SyWOpn1 call SyDesktop_WaitMessage
        cp MSR_DSK_WOPNER
        scf
        ret z               ;return with set carry flag, if window couldn't be opened
        cp MSR_DSK_WOPNOK
        jr nz,SyWOpn1       ;different message than "open ok" -> continue waiting
        ld a,(iy+4)         ;get window ID and return with cleared carry flag
        ret
EndLib

Library SyDesktop_WINMEN
;******************************************************************************
;*** Name           Window_Redraw_Menu_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws the menu bar of a window. If you changed your menus you
;***                should call this command to update the screen display.
;******************************************************************************
        ld c,MSC_DSK_WINMEN
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WININH
;******************************************************************************
;*** Name           Window_Redraw_Content_Command
;*** Input          A  = Window ID
;***                E  = -1, control ID or negative number of controls
;***                     000 - 239 -> the control with the specified ID will be
;***                                  redrawed.
;***                     240 - 254 -> redraws -P2 controls, starting from
;***                                  control P3. As an example, if P2 is -3
;***                                  (253) and P3 is 5, the controls 5, 6 and 7
;***                                  will be redrawed.
;***                     255       -> redraws all controls inside the window
;***                                  content.
;***                - if E is between 240 and 254:
;***                D = ID of the first control, which should be redrawed.
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws one, all or a specified number of controls inside the
;***                window content. This command is very important, if you make
;***                changes and want to display them.
;***                This command is identical with MSC_DSK_WINDIN with the
;***                exception, that it only works, if the window has focus. Because
;***                of this, it is a little bit faster, as the desktop manager
;***                doesn't need to take care about other windows, which could hide
;***                some parts of the window.
;******************************************************************************
        ld c,MSC_DSK_WININH
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINTOL
;******************************************************************************
;*** Name           Window_Redraw_Toolbar_Command
;*** Input          A  = Window ID
;***                E  = -1, control ID or negative number of controls
;***                     000 - 239 -> the control with the specified ID will be
;***                                  redrawed.
;***                     240 - 254 -> redraws -P2 controls, starting from
;***                                  control P3. As an example, if P2 is -3
;***                                  (253) and P3 is 5, the controls 5, 6 and 7
;***                                  will be redrawed.
;***                     255       -> redraws all controls inside the window
;***                                  toolbar.
;***                - if E is between 240 and 254:
;***                D = ID of the first control, which should be redrawed.
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws one, all or a specified number of controls inside the
;***                window toolbar. Use this command to update the screen display,
;***                if you made changes in the toolbar.
;******************************************************************************
        ld c,MSC_DSK_WINTOL
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINTIT
;******************************************************************************
;*** Name           Window_Redraw_Title_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws the title bar of a window. Use this command to update
;***                the screen display, if you changed the text of the window
;***                title.
;******************************************************************************
        ld c,MSC_DSK_WINTIT
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINSTA
;******************************************************************************
;*** Name           Window_Redraw_Statusbar_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws the status bar of a window. Use this command to update
;***                the screen display, if you changed the text of the status bar.
;******************************************************************************
        ld c,MSC_DSK_WINSTA
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMVX
;******************************************************************************
;*** Name           Window_Set_ContentX_Command
;*** Input          A  = Window ID
;***                DE = new X offset of the visible window content
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    If the size of the window content is larger than the visible
;***                part, you can scroll its X offset with this command. The
;***                command works also, if the window is not resizeable by the
;***                user.
;******************************************************************************
        ld c,MSC_DSK_WINMVX
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMVY
;******************************************************************************
;*** Name           Window_Set_ContentY_Command
;*** Input          A  = Window ID
;***                DE = new Y offset of the visible window content
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    If the size of the window content is larger than the visible
;***                part, you can scroll its Y offset with this command. The
;***                command works also, if the window is not resizeable by the
;***                user.
;******************************************************************************
        ld c,MSC_DSK_WINMVY
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINTOP
;******************************************************************************
;*** Name           Window_Focus_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    Takes the window to the front position on the screen.
;******************************************************************************
        ld c,MSC_DSK_WINTOP
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMAX
;******************************************************************************
;*** Name           Window_Size_Maximize_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if the window is minimized or restored
;*** Description    Maximizes a window. A maximized window has a special status,
;***                where it can't be moved to another screen position.
;******************************************************************************
        ld c,MSC_DSK_WINMAX
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMIN
;******************************************************************************
;*** Name           Window_Size_Minimize_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if the window is maximized or restored
;*** Description    Minimizes a window. It will disappear from the screen and can
;***                only be accessed by the user via the task bar.
;******************************************************************************
        ld c,MSC_DSK_WINMIN
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMID
;******************************************************************************
;*** Name           Window_Size_Restore_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if the window is maximized or minimized
;*** Description    Restores the window or the size of the window, if it was
;***                minimized or maximized before.
;******************************************************************************
        ld c,MSC_DSK_WINMID
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMOV
;******************************************************************************
;*** Name           Window_Set_Position_Command
;*** Input          A  = Window ID
;***                DE = new X window position
;***                HL = new Y window position
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if the window is not maximized
;*** Description    Moves the window to another position on the screen. This will
;***                not work, if the window is maximized.
;******************************************************************************
        ld c,MSC_DSK_WINMOV
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINSIZ
;******************************************************************************
;*** Name           Window_Set_Size_Command
;*** Input          A  = Window ID
;***                DE = new window width
;***                HL = new window height
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    Resizes a window. This command will always work, even if the
;***                window is not resizeable by the user.
;***                Please note, that the size always refers to the visible content
;***                of the window, not to the whole window including the control
;***                elements. So with title bar, scroll bars etc. a window can have
;***                a bigger size on the screen.
;******************************************************************************
        ld c,MSC_DSK_WINSIZ
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINCLS
;******************************************************************************
;*** Name           Window_Close_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    Closes the window. The desktop manager will remove it from the
;***                screen.
;******************************************************************************
        ld c,MSC_DSK_WINCLS
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINDIN
;******************************************************************************
;*** Name           Window_Redraw_ContentExtended_Command
;*** Input          A  = Window ID
;***                E  = -1, control ID or negative number of controls
;***                     000 - 239 -> the control with the specified ID will be
;***                                  redrawed.
;***                     240 - 254 -> redraws -P2 controls, starting from
;***                                  control P3. As an example, if P2 is -3
;***                                  (253) and P3 is 5, the controls 5, 6 and 7
;***                                  will be redrawed.
;***                     255       -> redraws all controls inside the window
;***                                  content.
;***                - if E is between 240 and 254:
;***                D = ID of the first control, which should be redrawed.
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    Redraws one, all or a specified number of controls inside the
;***                window content. This command is identical with MSC_DSK_WININH
;***                with the exception, that it always works but with less speed.
;***                For more information see MSC_DSK_WININH.
;******************************************************************************
        ld c,MSC_DSK_WINDIN
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINSLD
;******************************************************************************
;*** Name           Window_Redraw_Slider_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws the two slider of the window, with which the user can
;***                scroll the content. Sliders will only be displayed, if the
;***                window is resizeable.
;***                Usally you should use MSC_DSK_WINMVX and MSC_DSK_WINMVY to
;***                scroll the content of the window. These commands will update
;***                the sliders by themself.
;***                If you manipulate the content position in the window data
;***                record by yourself, you can use this command to update the
;***                screen display.
;******************************************************************************
        ld c,MSC_DSK_WINSLD
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_MODGET
;******************************************************************************
;*** Name           DesktopService_ScreenModeGet
;*** Input          -
;*** Output         E  = Screen mode
;***                     0 = 160 x 200, 16 colours
;***                     1 = 320 x 200,  4 colours (standard mode)
;***                     2 = 640 x 200,  2 colours
;*** Destroyed      F,BC,DE,HL,IX,IY
;*** Description    Returns the actual screen resolution and number of possible
;***                colours.
;******************************************************************************
        ld a,DSK_SRV_MODGET
        jp SyDesktop_Service
EndLib

Library SyDesktop_MODSET
;******************************************************************************
;*** Name           DesktopService_ScreenModeSet
;*** Input          E  = Screen mode
;***                     0 = 160 x 200, 16 colours
;***                     1 = 320 x 200,  4 colours (standard mode)
;***                     2 = 640 x 200,  2 colours
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sets the screen resolution and number of possible colours.
;******************************************************************************
        ld a,DSK_SRV_MODSET
        jp SyDesktop_Service
EndLib

Library SyDesktop_COLGET
;******************************************************************************
;*** Name           DesktopService_ColourGet
;*** Input          E  = Colour number (0-15)
;*** Output         D  = Bit[0-3] blue  component (0-15)
;***                     Bit[4-7] green component (0-15)
;***                L  = Bit[0-3] red   component (0-15)
;*** Destroyed      AF,BC,E,H,IX,IY
;*** Description    Returns the definition of a colours. Please note, that you
;***                always have a range of 4096, even if the computer is not a CPC
;***                PLUS, as the system recalculates the colour for standard CPCs
;***                (factor 5,33 for each component).
;******************************************************************************
        ld a,DSK_SRV_COLGET
        jp SyDesktop_Service
EndLib

Library SyDesktop_COLSET
;******************************************************************************
;*** Name           DesktopService_ColourSet
;*** Input          E  = Colour number (0-15)
;***                D  = Bit[0-3] blue  component (0-15)
;***                     Bit[4-7] green component (0-15)
;***                L  = Bit[0-3] red   component (0-15)
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Defines one colour. Please note, that you always have a range
;***                of 4096, even if the computer is not a CPC PLUS, as the system
;***                recalculates the colour for standard CPCs (factor 5,33 for each
;***                component).
;******************************************************************************
        ld a,DSK_SRV_COLSET
        jp SyDesktop_Service
EndLib

Library SyDesktop_DSKBGR
;******************************************************************************
;*** Name           DesktopService_RedrawBackground
;*** Input          -
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Redraws the desktop background.
;******************************************************************************
        ld a,DSK_SRV_DSKBGR
        jp SyDesktop_Service
EndLib

Library SyDesktop_DSKPLT
;******************************************************************************
;*** Name           DesktopService_RedrawComplete
;*** Input          -
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Redraws the complete screen. The background, the task bar and
;***                all windows will be updated.
;******************************************************************************
        ld a,DSK_SRV_DSKPLT
        jp SyDesktop_Service
EndLib


;### SUB ROUTINES #############################################################

Library SyDesktop_SendMessage
;******************************************************************************
;*** Input          C  = Command
;***                A  = Window ID
;***                DE,HL = additional parameters
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sends a message to the desktop manager, which includes the
;***                window ID and additional parameters
;******************************************************************************
        ld iy,AppMsgB
        ld (iy+0),c
        ld (iy+1),a
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        db #dd:ld h,2       ;2 is the number of the desktop manager process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #10
        ret
EndLib

Library SyDesktop_WaitMessage
;******************************************************************************
;*** Input          -
;*** Output         IY = message buffer
;***                A  = first byte in the Message buffer (IY+0)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sends a message to the desktop manager, which includes the
;***                window ID and additional parameters
;******************************************************************************
        ld iy,AppMsgB
SyDWMs1 db #dd:ld h,2       ;2 is the number of the desktop manager process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #08             ;wait for a desktop manager message
        db #dd:dec l
        jr nz,SyDWMs1
        ld a,(iy+0)
        ret
EndLib

Library SyDesktop_Service
;******************************************************************************
;*** Input          A     = Function
;***                DE,HL = additional parameters
;*** Output         DE,HL = returned parameters
;*** Destroyed      AF,BC,IX,IY
;*** Description    Sends a service request message to the desktop manager,
;***                waits for the answer and returns with the result
;******************************************************************************
        ld c,MSC_DSK_DSKSRV
        ld (SyDSrvN),a
        call SyDesktop_SendMessage
SyDSrv1 call SyDesktop_WaitMessage
        cp MSR_DSK_DSKSRV
        jr nz,SyDSrv1
        ld a,(SyDSrvN)
        cp (iy+1)
        jr nz,SyDSrv1
        ld e,(iy+2)
        ld d,(iy+3)
        ld l,(iy+4)
        ld h,(iy+5)
        ret
SyDSrvN db 0
EndLib
.AppTrnEnd


